*H SCPSCH2.S
;*****************************************************************************
;*
;*    Bios-Teil zur Treiberansteuerung unter SCP 5105
;*    Auswertung I/O Byte & Treibertabelle fuer zeichenweise arbeitende
;*    E/A Geraete
;*----------------------------------------------------------------------------
;*    Erarbeitet : Elssner/Schlegel
;*    File: SCPSCH2.S
;*    Stand: 17.05.89
;*
;*****************************************************************************
LREB	EQU	0CH
 external OUTASC
;
 global	 CONST	CONIN	CONOUT	LIST	PUNCH	READER
 global	 LISTST	CONOST	AUXIST	AUXOST	DEVTBL
;-----------------------------------------------------------
;Programm muss im ROM stehen, wird vom BIOS gerufen
;Parameter fuer jeden BIOS-Ruf laden
;---------------------------------------------------
;CONSOLE
CONST:	LD	A,0	;Consolenstatus Eingabe  (BIOS-02)
	JR	CON0
CONIN:  LD	A,1	;Consoleneingabe	 (BIOS-03)
	JR	CON0
CONOUT:	LD	A,2	;Consolenausgabe	 (BIOS-04)
	JR	CON0
CONOST:	LD	A,3	;Consolenausgabestatus	 (BIOS-17)
CON0:	LD	B,0
	LD	D,'C'
	JP	TRRUF2
;----------------------------------------------------
;READER
AUXIST: LD	A,0	;Readerstatus		 (BIOS-18)
	JR	RDR
READER:	LD	A,1	;Reader			 (BIOS-07)
RDR:	LD	B,1
	LD	D,'R'
	JP	TRRUF2
;----------------------------------------------------
;PUNCH
AUXOST: LD	A,3	;Puncher-Status		 (BIOS-19)
	JR	PUN
PUNCH:	LD	A,2	;Ausgabe auf Punch	 (BIOS-06)
PUN:	LD	B,2
	LD	D,'P'
	JP	TRRUF2
;----------------------------------------------------
;LIST
LISTST:	LD	A,3	;List-Status		 (BIOS-15)
	JR	LST
LIST:	LD	A,2	;Ausgabe auf Listger.	 (BIOS-05)	
LST:	LD	B,3
	LD	D,'L'
	JP	TRRUF2
	;TRRUF2 ist Sprung zu Treiberaufrufprg.(steht im RAM)
;*****************************************************************************
;*
;*    Bios-Teil zur Treiberansteuerung unter SCP 5105
;*    Auswertung I/O Byte & Treibertabelle fuer zeichenweise arbeitende
;*    E/A Geraete
;*----------------------------------------------------------------------------
;*    Erarbeitet : Elssner/Schlegel
;*
;*****************************************************************************
        ;Programm muss im ROM stehen
	;Ermittlung von Treiberadresse und Slotnummer des angesprochenen
	;Treibers
	;bei Aufruf  B= log. Tabellennr.   C= I/O Byte
	;Rueckkehr   BC= Treiberadresse    A= Slot fuer TREIA
	;Rueckkehr   HL= Pos. in TRTAB    DE= Pos. in SLTAB zus. fuer BIOS Ruf
DEVTBL:	LD	A,B
	ADD	A,A
	AND	00000110B
	LD	B,A
	LD	E,A		;Log. Tabnr.
	LD	D,0
	LD	A,C		;I/O Byte
	JR	Z,SH1
	;-----------------------------------
SH:	SRL	A		;verschiebe rechts und fuelle mit 0
	DJNZ	SH		;bis die zwei signifik. Bits in 1&0
SH1:	SLA	E		;log.Tabnr. in E (0,4,8,12)
	AND	3		;Bits von I/O Byte 000000XX
	ADD	A,E		;zu log. Tabnr.    0000XX||
	LD	E,A
	LD	HL,SLTAB	;Anfangsadr. d. Tabelle d. Slotnummern
	ADD	HL,DE		;+ log. Tabellennummer & I/O Bytestellung
	PUSH	HL		;Position der Slotnr. d. Treibers auf Stack
	LD	HL,TRTAB	;Anfangsadr d. Tabelle d. Treiberadressen
	ADD	HL,DE		;+ log. Tabellennr. und I/O Bytestellung
	ADD	HL,DE		;nochmal, da 2-Byte Tabelle
	LD	C,(HL)
	INC	HL
	LD	B,(HL)		;BC= Treiberanfangsadresse				
	DEC	HL		;HL= Position in Treiberadresstabelle
	POP	DE		;DE= Position in der Slottabelle
	LD	A,(DE)		;A = Slotadresse
	RET			;Rueckkehr ins RAM zu TREIA-prg.
;***********************************************************************
;*
;*  Programmteil TREIA
;*  erstellt: Elssner/Schlegel
;***********************************************************************
;*  Registerinhalt Aufruf: A=Funktionscode, B=Kanal, C=Zeichen
;*  ruft Treiber fuer Zeichenweise arbeitende E/A Geraete auf
;**********************************************************************
IOBYTE	EQU	3
;---------------------------------------------------------------------
;
;=== Laenge = 29 === im RAM von Hand aendern ! ===
TTREIA:	PUSH	AF		;Funktionscode auf Stack legen
;
;	PUSH	BC		;Kanal und Zeichen f. Ausg. auf Stack
;	LD	A,02H		;holen I/O Byte
;	LD	HL,IOBYTE	;von Bank 2
;	CALL	LREB
;	POP	BC
;
	IN	A,(PPIA)	;ist schneller !
	PUSH	AF
	AND	0FCH
	OR	2
	OUT	(PPIA),A
	LD	HL,IOBYTE
	LD	H,(HL)
	POP	AF
	OUT	(PPIA),A
;
	PUSH	BC
	LD	C,H		;in C uebertragen
	CALL	DEVTBL		;Aufruf UP zur Ermittlung der Treiberadresse
				;und des Slots des Treibers
	OUT	(PPIA),A	;einstellen der Slotbelegung in der Treiber
				;angesprungen werden muss
	LD	L,C		;Umlagern Treiberadresse von BC nach HL
	LD	H,B
	POP	BC		;holen Kanal & Zeichen vom Stack
	POP	AF		;holen Funktionscode vom Stack
	JP	(HL)		;Ansprung Treiber
;Parameter zum Treiberaufruf A= Funktionscode
;			     C= Zeichen fuer Ausgabe
;Auf Stack liegt Rueckkehradresse des Treibers ins BIOS (siehe Ludewig)
;nach Rueckkehr wird im BIOS-Rahmen (Ludewig) auf Slotbelegung vor Auf-
;ruf rueckgeschaltet
;----------------------------------------------------------------------
;=== Laenge = 32 === im RAM von Hand aendern ! ===
TRRUF0:	LD	HL,STTREI
	LD	(HL),D		;Zeichen in Statuszeile ein
	PUSH	BC
	CALL	TRBSCH		;Adresse errechnen und Treiber aufrufen
	POP	BC
	PUSH	AF
	LD	A,' '
	LD	(STTREI),A	;Zeichen in Statuszeile aus
	POP	AF
	RET	NC		;OK
	LD	A,10101010B
	OUT	(PPIA),A	;alles RAM fuer Warmstart
	LD	A,B		;Geraetecode (LIST=3)
	CP	3
	JP	NZ,0		;Warmstart
	XOR	A		;wenn Fehler im LIST-Treiber, dann
	LD	(BDV3),A	;^P ausschalten
	RST	0		;und Warmstart
;---------------------------------------------------------------------
;Tabelle fuer Treiberanfangsadressen (liegen im RAM)
TTRTAB:	DEFW	DUMMYT		;Console TTY
	DEFW	CON		;Console CRT
	DEFW	DUMMYT		;Console BAT
	DEFW	V24SC		;Console UC1
;
	DEFW	CON		;Reader  TTY
	DEFW	V24SR		;Reader  PTR
	DEFW	DUMMYT		;Reader  UR1
	DEFW	DUMMYT		;Reader  UR2
;
	DEFW	CON		;Puncher TTY	
	DEFW	V24SP		;Puncher PTP
	DEFW	DUMMYT		;Puncher UP1
	DEFW	V24PP		;Puncher UP2
;
	DEFW	V24PP		;List    TTY
	DEFW	CON		;List    CRT
	DEFW	V24PL		;List    LPT
	DEFW	V24SL		;List    UL1
;Tabelle fuer Slotadresse
TREIAE:				;Marke fuer Verschiebeende
;---------------------------------------------------------------------------
;Verschieberoutine fuer TREIA vom ROM ins RAM
COPTRA:	LD	HL,TTREIA	;wird aufgerufen vom Kaltstart
	LD	DE,TRBSCH
	LD	BC,TREIAE-TTREIA
	LDIR
;Anlegen der Slotbelegungstabelle mit Standartwert der SCP-Slotbelegung
	LD	A,(SLCTRL)	;Slotcontrol
	LD	B,16		;Tabellenlaenge
EOSLT:	LD	(DE),A
	INC	DE
	DJNZ	EOSLT
	RET			;zurueck an Kaltstart
;---------------------------------------------------------------------------
;Dummytreiber
;Bei Aufruf: A= Funktionscode, C=Ausgabezeichen
;Bei Return: CY=0  A= 0FFh bei Statusabfragen und Ausgaben
;	     CY=0  A= 01Ah bei Eingabeforderung (eof)
DUMMYT:	CP	1		;Eingabe ?
	LD	A,1AH
	RET	Z		;A=EOF (1AH) CY=0
	XOR	A
	DEC	A
	RET			;A=FFH (Status bereit) CY=0
; -------------------------------
; Consolentreiber Aufteilung in Tastatur und Bildschirm
CON:	LD	HL,NCRET
	PUSH	HL
	CP	2		;A = 0  -> TASTMO (Status Eing)
	JR	Z,CON1		;  = 1  -> TASTMO (Eingang)
	JP	C,TASTMO	;  = 2  -> (OUTASC, Ausgang)
	CP	0FFh		;  = 3  -> FF ret (Status Ausg)
	JP	Z,TASTMO	;  = FF -> TASTMO (Kaltst.)
	LD	A,0FFh
NCRET:	OR	A
	RET
CON1:	LD	A,C
	JP	OUTASC		;Zeichen in A
; -------------------------------
; die V24-Treiber befinden sich in SCPELV.S
; -------------------------------
; ENDE SCPSCH2.S
; -------------------------------
