;!HEAD MODULE
;FILE		BDOS.ROM.S
;DISK		
;AUTHOR		Kersten->Ludewig
;DATE		17.05.89
;VARIABLES	(hier nicht angegeben)
;END
;!
;
;
;
; File enthaelt den BDOS-Teil fuer BASIC und SCP, der immer im ROM steht.
;
;
;
;; Erforderliche Speicheraufteilung fuer Arbeit des BDOS:
;
; Disk-BASIC:	FFFF
;		 |	Bank 2 (RAM) : System-RAM + BASIC-Anwenderspeicher
;		8000
;		 |	Bank 1 oder 3 (ROM) : ROM-BDOS
;		4000
;		 |	Bank 0 (ROM) : BASIC-Treiber
;		0000
;
; SCP:		FFFF
;		 |	Bank 2 (RAM) : System-RAM mit BIOS-Sprungleiste
;		C000
;		 |	Bank 0 (ROM) : SCP-ROM (CCP, Treiber-Teile ...)
;		 |	(Sonderserie Bank 1 oder 3)
;		8000
;		 |	Bank 1 oder 3 (ROM) : ROM-BDOS
;		4000
;		 |	Bank 2 (RAM) : SCP-RAM (0 - 0FFh)
;		0000
;
; Erforderliche Speicher-Aufteilung fuer SCP-Dienstprogramme:
;
;		FFFF
;		 |	Bank 2 (RAM)
;		8000
;		 |	Bank 2 (RAM)
;		4000
;		 |	Bank 2 (RAM)
;		0000
*EJEC
;
;************************************************************
;
;; modifizierungen gegenueber original cp/m 2.2: (Original Dames)
; -  um eine arbeit ohne lw a zu erlauben, wird das erste
;    default-lw nach kaltstart als $$$.sub-lw bei disk-reset
;    benutzt. dem anwenderprogramm wird dazu nach disk-reset
;    in h die kaltstart-lw-nr (a=0, b=1,..) und in l und a
;    ff bei vorhandener $-datei, 00 sonst uebergeben.
; -  um fuer pc1715 im directory "sauber" die loader-informa-
;    tionen unterzubringen, werden zu uebergehende dir-ein-
;    traege bei login nicht nur an USER=e5h, sondern auch
;    an filename[1] =00h oder >=f0h erkannt.
; -  einfuehrung eines kopierschutzes:
;    eine $$$-datei kann nicht in eine datei mit gesetztem
;    bit 7 im 3. typ-byte umbenannt werden (file r/o -meldung)
;    die $$$-eintragung im directory wird unkenntlich gemacht.
; -  ix und iy werden vom BDOS gerettet und wiederhergestellt
; -  einsparung von bytes durch einfuehrung von jr-spruengen
;    und streichen von steuerzeichen fuer nicht-bildschirm-
;    konsolen.
; -  beschleunigung der arbeit mit fcb(0)=0 indem nicht sofort
;    wieder auf current-laufwerk zurueckgeschaltet wird
; -  das puffern von zeichen im BDOS entfaellt zusammen mit der
;    ^s-funktion (nur dafuer noetig), da im BIOS ein allgemei-
;    nes stop des rechners implementiert ist (ci-taste).
; -  ^s wirkt wie ^h (falls ^h-taste zu ^s umdefiniert wurde)
; -  verlegung des sprungverteilers fuer die BDOS-funktionen
;    nach vorn, damit speicherschutz von BDOS+40h moeglich ist.
; -  fehlerkorrektur bei selektivem lw-reset (fkt. 25h), funktionierte
;    nur bei zwischenzeitlichem lw-wechsel
;*************************************************************
*EJEC
;
	GLOBAL	INITBB
	GLOBAL	CRLF	PUTSTR
;
;
PPIA:	EQU		0A8H	;Port Bankumschaltung
;
;; BDOS-Anlauf fuer BASIC
;
INITBB:	MOVE	BBDOS BBD0 BDFUNC-BBD0
	FLRAM	BDV0 SYSDV-BDV0+1 0
	LD	A,0E5H
	LD	(ERASE),A
	LD	HL,BDMA
	LD	(DMAADD),HL
	LD	(STDDMA),HL	; Standard-DMA
	LD	A,-1
	LD	(OLDDISK),A
	LD	A,0
	LD	(SYSDV),A 	; Kaltstart-Lw. := A
	RET
;
;; RAM-Abbild im ROM fuer BDOS-Anfang Disk-BASIC
;  (steht nach System-Anlauf im RAM)
;  =============================================
;
BBD0:	JP	BDOS1
;
	DFW	BFMELD BFMELD BFMELD BFMELD ; Fehlerbeh.-Adr.
;
;
sie34a:	ld	e,(hl)		;Hilfsprogramm Fehleranzeige
	inc	hl
	ld	d,(hl)
	ex	de,hl
	jp	(hl)            ; Ansprung Fehlerbehandlung
;
;
defaul	equ	4		;default-disk in rechter tetr.
;
;
;; verteiler-liste fuer BDOS-funktionen
;========================================
;
BDFUNC	DFW	IWBOOT,CONIN,CONOUT,READER,IPUNCH,ILIST
;6
	DFW	DIRCON,GETIOB,SETIOB,PRINTST,RCBUB,GETCST
;12 = 0ch
	DFW	VERSNM,RESDSK,SETDSK,OPEN,CLOSE,FIRST
;18 = 12h
	DFW	NEXT,DELETE,SEQREAD,SEQWRITE,MAKEF,RENAME
;24 = 18h
	DFW	LOGIN,CURRENT,SETDMA,GETALLOC,PROTECT,GETPRO
;30 = 1eh
	DFW	SETATTR,GETDPB,SGUSER,RANDRD,RANDWR,FSIZE
;36 = 24h
	DFW	SETRAND,RESDRIV,LEER,LEER,WRINIT
*EJEC
;; BDOS-Eingang fuer Disk-BASIC
;------------------------------
;
BDOS1:	ld	(DEPARM),de
	ld	a,e
	ld	(ENTBYTE),a
	xor	a
	ld	h,a
	ld	l,a
	ld	(HLPARM),hl
	ld	(USTACK),sp
	ld	sp,STACK
	ld	(FCB_0),a
	ld	(IFDISK),a	;flag: fcb nicht modifiziert
	push	ix
	push	iy
	ld	hl,Return	;standard-ausgang
	push	hl
	ld	a,c
	cp	29h
	ret	nc 		; = JP Return
	ld	c,e
	ld	hl,BDFUNC
	ld	e,a
	ld	d,0
	add	hl,de
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,(DEPARM)
	ex	de,hl
	jp	(hl) 		; Ausgang BDOS-Funktion
;-----------------------
;; Allgemeiner BDOS-ausgang
;=========================
Return:	ld	a,(IFDISK)	;fcb[0] veraendert?
	or	a
	jr	z,ied91		;nein
	ld	hl,(DEPARM)
	ld	a,(FCB_0)	;gerettetes fcb[0]
	ld	(hl),a		;fcb[0] auf alten wert zurueck
ied91:	pop	iy
	pop	ix
	ld	sp,(USTACK)
	ld	hl,(HLPARM)
	ld	a,l
	ld	b,h
	ret
;; Abspeicherung Fehlermeldung fuer BASIC
;
BFMELD:	LD	HL,0FFFEH	; Fehler-Kennung
	LD	(HLPARM),HL
	LD	SP,STACK-4	; ( wegen IY, IX )
	JP	Return
;-----------------------
;; Sprung zur Fehlerbehandlung im BDOS
;
ie347:	ld	hl,BADSEL 	; <HL> := >Fehlerbehandlung<
	JP	ie34a
*EJEC
;
;; Zeicheneingabe mit Echo auf Bildschirm
;
ie106:	call	ICONIN
	call	IFCTL
	ret	c
	push	af
	ld	c,a
	call	CONOUT
	pop	af
	ret
;
;; Kontrolle auf Steuerzeichen
;
;  (bei CR, LF, HT, BS Zero
;   bei sonstigen Steuerzeichen Carry)
;
IFCTL:	cp	0dh
	ret	z
	cp	0ah
	ret	z
	cp	09h
	ret	z
	cp	08h
	ret	z
	cp	20h
	ret
;-----------------------
ie123:	call	ICONST
	and	01h
	ret
;-----------------------
*EJEC
;
ie148:	ld	a,(BDV0)
	or	a
	jr	nz,ie162
;	push	bc		;Ohne Stop mit ^S
;	call	ie123
;	pop	bc		; nicht erforderlich (Lu!)
	push	bc
	call	ICONOUT
	pop	bc
	push	bc
	ld	a,(BDV3)
	or	a
	call	nz,ILIST
	pop	bc
ie162:	ld	a,c
	ld	hl,BDV2
	cp	7fh
	ret	z
	inc	(hl)
	cp	20h
	ret	nc
	dec	(hl)
	ld	a,(hl)
	or	a
	ret	z
	ld	a,c
	cp	08h
	jr	nz,ie179
	dec	(hl)
	ret
;-----------------------
ie179:	cp	0ah
	ret	nz
	ld	(hl),0
	ret
;
;; Kontrolle auf Steuerzeichen + Ausgabe auf Bildschirm
;;  Vor Steuerzeichen "^" ausgeben
;
ie17f:	ld	a,c
	call	IFCTL
	jr	nc,CONOUT
	push	af
	ld	c,5eh
	call	ie148
	pop	af
	or	40h
	ld	c,a
*EJEC
;
;; Ausgabe 1 Zeichen (aus C)
;
CONOUT:	ld	a,c
	cp	09h
	jr	nz,ie148
ie196:	ld	c,20h
	call	ie148
	ld	a,(BDV2)
	and	07h
	jr	nz,ie196
	ret
;
;; Ausgabe Back space
;
ie1a4:	call	ie1ac
	ld	c,20h
	call	ICONOUT
ie1ac:	ld	c,08h
	jp	ICONOUT
;
;; Ausfuehrung ^R (Echo auf neuer Zeile)
;
ie1b1:	ld	c,'#'
	call	ie148
	call	CRLF
ie1b9:	ld	a,(BDV2)
	ld	hl,BDV1
	cp	(hl)
	ret	nc
	ld	c,20h
	call	ie148
	jr	ie1b9
;-----------------------
CRLF:	ld	c,0dh
	call	ie148
	ld	c,0ah
	jp	ie148
;-----------------------
PUTSTR:	ld	a,(bc)
	cp	'$'
	ret	z
	inc	bc
	push	bc
	ld	c,a
	call	CONOUT
	pop	bc
	jr	PUTSTR
*EJEC
;
;; Funktion 10 - Read console buffer
;
RCBUB:	ld	a,(BDV2)
	ld	(BDV1),a
	ld	hl,(DEPARM)
	ld	c,(hl)
	inc	hl
	push	hl
	ld	b,0
ie1ef:	push	bc
	push	hl
ie1f1:	call	ICONIN
	and	7fh
	pop	hl
	pop	bc
	cp	0dh
	jp	z,ie2c1
	cp	0ah
	jp	z,ie2c1
	cp	13h		;^s
	jr	z,back		;wie ^h
	cp	08h
	jr	z,back		;***del-taste***
	cp	7fh		;***del-taste*** wie ^h
	jr	nz,ie226	;***del-taste***
back:	ld	a,b
	or	a
	jr	z,ie1ef		;***del-taste***
	dec	b
	ld	a,(BDV2)
	ld	(BDV0),a
	jr	ie270		;***del-taste***
;-----------------------
ie226:	cp	05h
	jr	nz,ie237	;***del-taste***
	push	bc
	push	hl
	call	CRLF
	xor	a
	ld	(BDV1),a
	jr	ie1f1
;-----------------------
ie237:	cp	10h
	jr	nz,ie248
	push	hl
	ld	hl,BDV3
	ld	a,01h
	sub	(hl)
	ld	(hl),a
	pop	hl
	jr	ie1ef
;-----------------------
*EJEC
;
ie248:	cp	18h
	jr	nz,ie2a6	;***ignorieren ctl-u, ctl-r***
	pop	hl
ie24e:	ld	a,(BDV1)
	ld	hl,BDV2
	cp	(hl)
	jr	nc,RCBUB
	dec	(hl)
	call	ie1a4
	jr	ie24e
;-----------------------
ie270:	push	bc
	call	ie1b1
	pop	bc
	pop	hl
	push	hl
	push	bc
ie278:	ld	a,b
	or	a
	jr	z,ie28a
	inc	hl
	ld	c,(hl)
	dec	b
	push	bc
	push	hl
	call	ie17f
	pop	hl
	pop	bc
	jr	ie278
;-----------------------
ie28a:	push	hl
	ld	a,(BDV0)
	or	a
	jp	z,ie1f1
	ld	hl,BDV2
	sub	(hl)
	ld	(BDV0),a
ie299:	call	ie1a4
	ld	hl,BDV0
	dec	(hl)
	jr	nz,ie299
	jp	ie1f1
;-----------------------
*EJEC
ie2a6:	inc	hl
	ld	(hl),a
	inc	b
ie2a9:	push	bc
	push	hl
	ld	c,a
	call	ie17f
	pop	hl
	pop	bc
	ld	a,(hl)
	cp	03h
	ld	a,b
	jr	nz,ie2bd
	cp	01h
	jp	z,0
ie2bd:	cp	c
	jp	c,ie1ef
ie2c1:	pop	hl
	ld	(hl),b
	ld	c,0dh
	jp	ie148
;
;; Funktion 1 - Console input
;
CONIN:	call	ie106
	jr	ie301
;
;; Funktion 3 - Reader input
;
READER:	call	IREADER
	jr	ie301
;
;; Funktion 6 - Direct console I/O
;
DIRCON:	ld	a,c
	inc	a
	jr	z,ie2e0
	inc	a
	jp	z,ICONST
	jp	ICONOUT
;-----------------------
ie2e0:	call	ICONST	;const
	or	a		;zeichen da?
	ret	z		;nein, return mit a=00
	call	ICONIN	;conin
	jr	ie301		;und a:=zeichen
*EJEC
;; Funktion 7 - Get I/O-Byte
;
GETIOB:	ld	a,(3)
	jr	ie301
;
;; Funktion 8 - Set I/O-Byte
;
SETIOB:	ld	hl,0003h
	ld	(hl),c
	ret
;
;; Funktion 9 - Print string
;
PRINTST:	ex	de,hl
	ld	c,l
	ld	b,h
	jp	PUTSTR
;
;; Funktion 11 - Get console status
;
GETCST:	call	ie123
ie301:	ld	(HLPARM),a
ie304:
LEER:	ret
;-----------------------
ie305:	ld	a,01h
	jr	ie301
*EJEC
;; Vorbereiten der Parameter der ausgewaehlten Diskette
;
Prepar:	ld	a,(CURRD)
	ld	c,a
	call	ISELDSK
	ld	a,h
	or	l
	ret	z 		; Fehler-Rueckkehr mit Zero
				;  (Lw nicht vorhanden,
				;   Disk nicht gesteckt,
				;   Format nicht erkennbar)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	(ADJOB1),hl	;^(grenze aktiver dir-entries)
	inc	hl
	inc	hl
	ld	(ADJOB2),hl
	inc	hl
	inc	hl
	ld	(ADJOB3),hl
	inc	hl
	inc	hl
	ex	de,hl
	ld	(ADXLT),hl
	ld	hl,ADDIR
	ld	bc,08h
	ex	de,hl
	call	FLLDIR
	ex	de,hl
	ld	hl,(ADDPB)
	ex	de,hl
	ld	hl,CSPT
	ld	bc,0fh
	ex	de,hl
	call	FLLDIR
	ex	de,hl
	ld	hl,(CDSM)
	ld	a,h
	ld	hl,BLOCK
	ld	(hl),0ffh
	or	a
	jr	z,ie39d
	ld	(hl),0
ie39d:	ld	a,0ffh
	or	a
	ret 			; ordnungsgemaesse Rueckkehr mit NoZero
*EJECT
;; home
;
ie3a1:	call	IHOME
	xor	a
	ld	hl,(ADJOB2)	;rel. track :=0
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ld	hl,(ADJOB3)	;rel. sector :=0
	ld	(hl),a
	inc	hl
	ld	(hl),a
	ret
;
;; Lesen Sektor von Diskette
;
Read:	call	IREAD
	jr	ie3bb
;
;; Schreiben Sektor auf Diskette
;
Write:	call	IWRITE	;write
ie3bb:	or	a		;ok?
	ret	z
	ld	hl,BADSEC	;nein, fehlermeldung
	jp	ie34a
*EJECT
;; stellen trk, sec im BIOS fuer dirbuf-transfer
;
ie3c3:	ld	hl,(NMBDIR)	;dir-entry
	ld	c,02h
	call	ie4ea		;div 4 = benoetiger record
	ld	(NMBREC),hl
	ld	(dedec),hl
ie3d1:	ld	hl,NMBREC
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ADJOB3)	;rel. sektor zu offset
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	hl,(ADJOB2)	;rel. track zu offset
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
ie3e4:	ld	a,c
	sub	e
	ld	a,b
	sbc	a,d
	jr	nc,ie3fa
	push	hl
	ld	hl,(CSPT)
	ld	a,e
	sub	l
	ld	e,a
	ld	a,d
	sbc	a,h
	ld	d,a
	pop	hl
	dec	hl
	jr	ie3e4
;-----------------------
*EJEC
ie3fa:	push	hl
	ld	hl,(CSPT)
	add	hl,de
	jr	c,ie40f
	ld	a,c
	sub	l
	ld	a,b
	sbc	a,h
	jr	c,ie40f
	ex	de,hl
	pop	hl
	inc	hl
	jr	ie3fa
;-----------------------
ie40f:	pop	hl
	push	bc
	push	de
	push	hl
	ex	de,hl
	ld	hl,(COFF)
	add	hl,de
	ld	b,h
	ld	c,l
	call	ISETTRK		;settrk
	pop	de
	ld	hl,(ADJOB2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	de
	ld	hl,(ADJOB3)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	bc
	ld	a,c
	sub	e
	ld	c,a
	ld	a,b
	sbc	a,d
	ld	b,a
	ld	hl,(ADXLT)
	ex	de,hl
	call	ISECTRAN	;sectran
	ld	c,l
	ld	b,h
	jp	ISETSEC		;setsec
*EJEC
;; Erhalten Block-Nr. D im FCB
;  entsprechend des aktuellen Satzes
;
GetDN:	ld	hl,CBSH
	ld	c,(hl)
	ld	a,(RECORD)
ie445:	or	a
	rra
	dec	c
	jr	nz,ie445
	ld	b,a
	ld	a,08h
	sub	(hl)
	ld	c,a
	ld	a,(EXTMAS)
ie453:	dec	c
	jr	z,ie45c
	or	a
	rla
	jr	ie453
;-----------------------
ie45c:	add	a,b
	ret
;
;; Herausholen logische Block-Nr. aus FCB
;  entsprechend seiner Nr. in BC
;
GetBlock:
	ld	hl,(DEPARM)
	ld	de,0010h
	add	hl,de
	add	hl,bc
	ld	a,(BLOCK)
	or	a
	jr	z,GetBl1
	ld	l,(hl)
	ld	h,0  		; <HL> := log. Block-Nr.
	ret
;-----------------------
GetBl1:	add	hl,bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ex	de,hl
	ret
*EJEC
;; Bestimmen log. Block-Nr fuer aktuellen Satz
;
SetBl:	call	GetDN
	ld	c,a
	ld	b,0
	call	GetBlock
	ld	(NMBREC),hl
	ret
;-----------------------
ie484:	ld	hl,(NMBREC)
	ld	a,l
	or	h
	ret
;
;; Berechnen Satz-Nr.
;
BerSNr:	ld	a,(CBSH)
	ld	hl,(NMBREC)
ie490:	add	hl,hl
	dec	a
	jr	nz,ie490
	ld	(dede7),hl
	ld	a,(CBLM)
	ld	c,a
	ld	a,(RECORD)
	and	c
	or	l
	ld	l,a
	ld	(NMBREC),hl
	ret
;-----------------------
;; adressieren extent-nr.
;
ie4a6:	ld	hl,(DEPARM)
	ld	de,000ch
	add	hl,de
	ret
;-----------------------
ie4ae:	ld	hl,(DEPARM)
	ld	de,000fh
	add	hl,de
	ex	de,hl
	ld	hl,0011h
	add	hl,de		; <DE> --> FCB[15] = rc
	ret 			; <HL> --> FCB[32] = cr
*EJEC
ie4bb:	call	ie4ae
	ld	a,(hl)
	ld	(RECORD),a
	ex	de,hl
	ld	a,(hl)
	ld	(COUNTR),a
	call	ie4a6 		; <HL> --> ext
	ld	a,(CEXM)
	and	(hl)
	ld	(EXTMAS),a
	ret
;-----------------------
ie4d2:	call	ie4ae
	ld	a,(SRMODE)
	cp	02h
	jr	nz,ie4de
	xor	a
ie4de:	ld	c,a
	ld	a,(RECORD)
	add	a,c
	ld	(hl),a
	ex	de,hl
	ld	a,(COUNTR)
	ld	(hl),a
	ret
;-----------------------
;; hl:= hl div (2**c)
;
ie4ea:	inc	c
ie4eb:	dec	c
	ret	z
	ld	a,h
	or	a
	rra
	ld	h,a
	ld	a,l
	rra
	ld	l,a
	jr	ie4eb
;-----------------------
;; kontrollsumme ueber dir-sector
DirCheck:
	ld	c,80h
	ld	hl,(ADDIR)
	xor	a
ie4fd:	add	a,(hl)
	inc	hl
	dec	c
	jr	nz,ie4fd
	ret
;-----------------------
*EJEC
ie504:	inc	c 		; Linksverschieben HL
ie505:	dec	c
	ret	z
	add	hl,hl
	jr	ie505
;
;; Einstellen von 1 fuer das aktuelle Laufwerk im Vektor,
;; dessen Adresse in BC angegeben ist
;
ie50b:	push	bc
	ld	a,(CURRD)
	ld	c,a
	ld	hl,0001h
	call	ie504
	pop	bc
	ld	a,c
	or	l
	ld	l,a
	ld	a,b
	or	h
	ld	h,a
	ret
;
;; Kontrolle des akt. LW auf R/O
;
ROCheck:ld	hl,(ROVEKT)	;r/o vektor
ie521:	ld	a,(CURRD)
	ld	c,a
	call	ie4ea
	ld	a,l
	and	01h		;CURRD r/o ?
	ret
*EJEC
;; Funktion 28 - Write protect disk
;
PROTECT:ld	hl,ROVEKT
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	ie50b
	ld	(ROVEKT),hl	;r/o-status setzen
	ld	hl,(CDRM)
	inc	hl
	ex	de,hl
	ld	hl,(ADJOB1)	;^(grenze aktiver dir-eintraege)
	ld	(hl),e		;stellen max.zahl fuer dir-suche
	inc	hl
	ld	(hl),d
	ret
;
;; Kontrolle Datei auf R/O
;
ie544:	call	ie55e		;hl auf dir-entry in dirbuf
ie547:	ld	de,0009h
	add	hl,de
	ld	a,(hl)		;file r/o-bit
	rla			;=1?
	ret	nc		;nein
filero:	ld	hl,FILERO	;fehlermeldung
	jp	ie34a
;-----------------------
ie554:	call	ROCheck		;disk r/o?
	ret	z		;nein
	ld	hl,DISKRO	;sonst fehlermeldung
	jp	ie34a
;-----------------------
;; hl:=dirbuf+(direntry*32)
;
ie55e:	ld	hl,(ADDIR)
	ld	a,(FCBOFFS)
ie564:	add	a,l
	ld	l,a
	ret	nc
	inc	h
	ret
;-----------------------
*EJEC
;; adressieren write-flag in fcb
ie569:	ld	hl,(DEPARM)
	ld	de,000eh
	add	hl,de
	ld	a,(hl)
	ret
;-----------------------
ie572:	call	ie569
	ld	(hl),0		;fcb ist nicht aktuell auf dsk.
	ret
;-----------------------
ie578:	call	ie569
	or	80h		;fcb ist aktuell auf diskette
	ld	(hl),a
	ret
;-----------------------
ie57f:	ld	hl,(NMBDIR)	;dir-nr.
	ex	de,hl
	ld	hl,(ADJOB1)	;^(anzahl aktiver dir-eintraege)
	ld	a,e
	sub	(hl)		;dirnr. - max.zahl
	inc	hl
	ld	a,d
	sbc	a,(hl)
	ret
;-----------------------
ie58c:	call	ie57f
	ret	c
	inc	de
	ld	(hl),d
	dec	hl
	ld	(hl),e
	ret
;-----------------------
ie595:	ld	a,e 		; <hl> := <de> - <hl>
	sub	l
	ld	l,a
	ld	a,d
	sbc	a,h
	ld	h,a
	ret
;-----------------------
*EJEC
ie59c:	ld	c,0ffh
;
;; bilden kontrollsumme ueber dir-sektor
; ic	=ff: kontrollsumme ablegen
;	=00: kontrollsumme vergleichen
;
ie59e:	ld	hl,(dedec)
	ex	de,hl
	ld	hl,(CCKS)
	call	ie595
	ret	nc
	push	bc
	call	DirCheck	;kontrollsumme dir.sector nach a
	ld	hl,(ADCHECK)
	ex	de,hl
	ld	hl,(dedec)
	add	hl,de
	pop	bc
	inc	c		;c=ff?
	jr	z,ie5c4		;ja, ablegen
	cp	(hl)		;stimmt kontrollsumme?
	ret	z		;ja
	call	ie57f		;nach akt. dir.-grenze?
	ret	nc		;ja
	jp	PROTECT		;sonst r/o setzen
;-----------------------
ie5c4:	ld	(hl),a		;kontrollsumme hinterlegen
	ret
;
;; Eintragen Verzeichnis-Sektor mit Korrektur Kontrollsumme
;
DirWr:	call	ie59c		;kontrollsumme ueber dir-sektor
	call	ie5e0		;setdma dirbuf
	ld	c,01h		;write to dir
	call	Write
	jr	DMARet
;
;; Lesen Verzeichnis-Sektor
;
DirRd:	call	ie5e0
	call	Read
DMARet:	ld	hl,DMAADD	;setdma zurueck
	jr	ie5e3
*EJEC
;; Einstellen DMA fuer Verzeichnis
;
ie5e0:	ld	hl,ADDIR
;
; Einstellen DMA
;
ie5e3:	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jp	ISETDMA	;setdma
;-----------------------
ie5e9:	ld	hl,(ADDIR)
	ex	de,hl
	ld	hl,(DMAADD)
	ld	bc,80h
	ex	de,hl
	call	FLLDIR
	ex	de,hl
	ret
;
;; Test ob ganzes Verzeichnis durchsucht
;
ie5f5:	ld	hl,NMBDIR	;aktuelle dir.nr.
	ld	a,(hl)
	inc	hl
	cp	(hl)		;=ffff?
	ret	nz		;nein
	inc	a		;sonst a=0, ret z
	ret
;-----------------------
;; direintragsnummer vor anfang stellen
;
ie5fe:	ld	hl,0ffffh 	; -1
	ld	(NMBDIR),hl
	ret
;
;; Kontrolle ob ganzes Verzeichnis durchsucht
;
ie605:	ld	hl,(CDRM)
	ex	de,hl
	ld	hl,(NMBDIR)	;akt. dir.nr
	inc	hl		;um 1 erhoehen
	ld	(NMBDIR),hl
	call	ie595		;dir.ende?
	jr	nc,ie619	;nein
	jr	ie5fe		;sonst wieder vor anfang
;-----------------------
*EJEC
ie619:	ld	a,(NMBDIR)
	and	03h
	ld	b,05h
ie620:	add	a,a
	dec	b
	jr	nz,ie620
	ld	(FCBOFFS),a
	or	a
	ret	nz
	push	bc
	call	ie3c3
	call	DirRd
	pop	bc
	jp	ie59e
;-----------------------
;; bestimmen byte in allocation-tabelle
;
ie635:	ld	a,c
	and	07h
	inc	a		;blocknr. mod 8 +1
	ld	e,a
	ld	d,a
	ld	a,c		;blocknr mod 256
	rrca
	rrca
	rrca
	and	1fh		;div 8
	ld	c,a
	ld	a,b		;blocknr. div 256 *256
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	add	a,a		;*32
	or	c
	ld	c,a		;low(blocknr. div 8)
	ld	a,b
	rrca
	rrca
	rrca
	and	1fh
	ld	b,a		;high(blocknr. div 8)
	ld	hl,(ADALLOC)
	add	hl,bc
	ld	a,(hl)		;allocation-byte
ie656:	rlca			;allocation-bit auf bit 0
	dec	e
	jr	nz,ie656
	ret
;-----------------------
*EJEC
;; setzen/loeschen block in  allocation-bit-tabelle
ie65c:	push	de
	call	ie635		;bestimmen byte
	and	0feh		;loeschen bit 0
	pop	bc
	or	c		;evtl. setzen bit 0
ie664:	rrca			;allocation-byte wieder zurueck
	dec	d
	jr	nz,ie664
	ld	(hl),a
	ret
;
;; verwalten allocation-bits fuer dir-eintrag
;
SetAll:	call	ie55e
	ld	de,0010h
	add	hl,de
	push	bc		;c=0 fuer loeschen, =1 fuer setzen
	ld	c,11h		;auszuwertende bytezahl +1
ie675:	pop	de
	dec	c		;fertig?
	ret	z		;ja, dir-eintrag ausgewertet
	push	de
	ld	a,(BLOCK)
	or	a		;2 bytes fuer BDOS-block?
	jr	z,ie688		;ja
	push	bc
	push	hl
	ld	c,(hl)		;sonst 1 byte
	ld	b,0
	jr	ie68e
;-----------------------
ie688:	dec	c
	push	bc
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	hl
ie68e:	ld	a,c		;BDOS-block =0?
	or	b
	jr	z,ie69d		;ja, ignorieren
	ld	hl,(CDSM)	;BDOS-block zu gross?
	ld	a,l
	sub	c
	ld	a,h
	sbc	a,b
	call	nc,ie65c	;nein, ist gueltig
ie69d:	pop	hl
	inc	hl
	pop	bc
	jr	ie675
;-----------------------
*EJEC
;;laufwerk erstmalig benutzt (login)
;==========================
Scan:	ld	hl,(CDSM)	;BDOS-bloecke -1
	ld	c,03h
	call	ie4ea		;hl:= hl div 8
	inc	hl		;+1  =bytezahl allocation-tabelle
	ld	b,h
	ld	c,l
	ld	hl,(ADALLOC)
ie6b1:	ld	(hl),0		;loeschen allocation-tabelle
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,ie6b1
	ld	hl,(CAL12)	;setzen dir-allocation
	ex	de,hl
	ld	hl,(ADALLOC)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	call	ie3a1		;home
	ld	hl,(ADJOB1)	;stellen max.dirzahl auf 3
	ld	(hl),03h
	inc	hl
	ld	(hl),0
	call	ie5fe
*EJEC
;; setzen allocation-tabelle, suchen akt. dir.-grenze
;; und ermitteln, ob $*.*-datei im directory (fuer ccp $$$.sub)
;
ie6d2:	ld	c,0ffh
	call	ie605
	call	ie5f5		;dir.ende?
	ret	z		;ja
	call	ie55e		;hl auf dir-eintrag
	ld	a,(hl)
	cp	0e5h		;leerer dir-eintrag?
	jr	z,ie6d2		;ja
	inc	hl
	ld	a,(hl)		;filename[1] aus dir-eintrag
	dec	hl
	add	a,10h		;f0..ff -> 00..0f; 00 -> 10
	cp	10h+1		;<=10h?
	jr	c,ie6d2		;ja, pc1715 loader-eintrag	
	ld	a,(USER)	;stimmt user?
	cp	(hl)
	jr	nz,ie6f6	;nein
	inc	hl
	ld	a,(hl)
	sub	'$'		;$-datei ? (fuer $$$.sub)
	jr	nz,ie6f6	;nein
	dec	a		;sonst ff
	ld	(HLPARM),a	;als returncode
ie6f6:	ld	c,01h		;anzeigen allocation setzen
	call	SetAll		;setzen allocation-bits
	call	ie58c
	jr	ie6d2
;-----------------------
ie701:	ld	a,(dedd4)
	jp	ie301
;-----------------------
;; vergleichen extent-nummer
;; ia	muster
;; ic	dir-eintrag
;
IfExt:	push	bc
	push	af
	ld	a,(CEXM)	;extent-mask
	cpl
	ld	b,a
	ld	a,c		;dir-eintrag (12)
	and	b		;extent-nr. frei
	ld	c,a
	pop	af		;muster
	and	b		;extent-nr. frei
	sub	c		;bit 4-0 gleich?
	and	1fh
	pop	bc
	ret
*EJEC
; suchen passenden dir-eintrag
; ic	anzahl der mit muster zu vergleichenden bytes
;
ie718:	ld	a,0ffh 	 	; = Fehlercode
	ld	(dedd4),a
	ld	hl,NMBSRCH
	ld	(hl),c
	ld	hl,(DEPARM)
	ld	(ENTFCB),hl
	call	ie5fe 		; Dir-Eintrag-Nr. vor Anfang
				;  ( <NMBDIR> := -1 )
	call	ie3a1 		; IHOME
;
; weitersuchen, wird von aussen angesprungen
;
ie72d:	ld	c,0
	call	ie605 		; Kontrolle, ob ganzes Verz. durchsucht
	call	ie5f5
	jr	z,ie794		;dir-ende erreicht
	ld	hl,(ENTFCB)	;^such-muster
	ex	de,hl
	ld	a,(de)
	cp	0e5h		;leeren dir-eintrag suchen?
	jr	z,ie74a		;ja
	push	de
	call	ie57f		;kommen noch aktive dir-eintraege?
	pop	de
	jr	nc,ie794	;nein, weitersuchen lohnt nicht
ie74a:	call	ie55e
	ld	a,(NMBSRCH)	;anzahl zu vergleichender bytes
	ld	c,a
	ld	b,0		;byteindex
ie753:	ld	a,c		;restl. bytezahl
	or	a		;fertig?
	jr	z,ie783		;ja
	ld	a,(de)
	cp	'?'		;beliebiges byte erlaubt?
	jr	z,ie77c		;ja
	ld	a,b
	cp	0dh		;byte 13?
	jr	z,ie77c		;ja, immer uebergehen
	cp	0ch		;byte 12?
	ld	a,(de)
	jr	z,ie773		;ja
	sub	(hl)		;sonst bit 6-0 vergleichen
	and	7fh
	jr	nz,ie72d	;stimmt nicht, naechster dir-eintrag
	jr	ie77c		;ist gleich, weiter
;-----------------------
*EJEC
ie773:	push	bc
	ld	c,(hl)
	call	IfExt		;vergleichen extent-nummer
	pop	bc
	jr	nz,ie72d
ie77c:	inc	de		;naechste bytes vergleichen
	inc	hl
	inc	b
	dec	c
	jr	ie753
;-----------------------
ie783:	ld	a,(NMBDIR) 	; Datei gefunden, Returncode setzen
	and	03h
	ld	(HLPARM),a
	ld	hl,dedd4
	ld	a,(hl)
	rla
	ret	nc 		; Fehler ?
	xor	a            	; Nein
	ld	(hl),a          ; Fehlercode := 0
	ret
;-----------------------
ie794:	call	ie5fe
	ld	a,0ffh
	jp	ie301
;
;; Loeschen Datei
;
EraFil:	call	ie554
	ld	c,0ch
	call	ie718
ie7a4:	call	ie5f5
	ret	z
	call	ie544
	call	ie55e
	ld	(hl),0e5h
	ld	c,0
	call	SetAll
	call	DirWr
	call	ie72d
	jr	ie7a4
*EJEC
;; Suchen freien Block  (Eingang: BC = Startblock fuer Suche
;			Ausgang: HL = Betr. Nr.  =  Gefunden
;				    = 0	 	 =  Nicht gef.
;
ie7be:	ld	d,b
	ld	e,c
ie7c0:	ld	a,c
	or	b
	jr	z,ie7d1
	dec	bc
	push	de
	push	bc
	call	ie635
	rra
	jr	nc,ie7ec
	pop	bc
	pop	de
ie7d1:	ld	hl,(CDSM)
	ld	a,e
	sub	l
	ld	a,d
	sbc	a,h
	jr	nc,ie7f4
	inc	de
	push	bc
	push	de
	ld	b,d
	ld	c,e
	call	ie635
	rra
	jr	nc,ie7ec
	pop	de
	pop	bc
	jr	ie7c0
;-----------------------
ie7ec:	rla
	inc	a
	call	ie664
	pop	hl
	pop	de
	ret
;-----------------------
ie7f4:	ld	a,c
	or	b
	jr	nz,ie7c0
	ld	hl,0
	ret
*EJEC
;; Gegebener FCB --> Verzeichnis
;
ie7fd:	ld	c,0		;relative position in fcb
	ld	e,20h		;byteanzahl
;
;; dir-eintrag modifizieren und neu schreiben
;
ie801:	push	de
	ld	b,0
	ld	hl,(DEPARM)
	add	hl,bc
	ex	de,hl		;de auf stelle in fcb
	call	ie55e		;hl auf dirbuf-eintrag
	pop	bc
	ld	b,0
	ex	de,hl
	call	FLLDIR		;move c bytes von fcb in dirbuf
	ex	de,hl
ie810:	call	ie3c3		;stellen trk,sec fuer dirbuf
	jp	DirWr
;
;; ausfuehren rename file
;=======================
FRen:	call	ie554		;test disk r/o
	ld	c,0ch		;12 bytes vergleichen
	call	ie718		;suchen passenden dir-eintrag
	ld	hl,(DEPARM)
;!!!kopierschutz fuer $$$-dateien mit bit 7 =1 im 3. typbyte
;!!!solche dateien koennen von einer $$$-endung nicht in die
;!!!wirkliche endung umbenannt werden, der dir-eintrag wird
;!!!unkenntlich gemacht
	push	hl
	pop	ix
	ld	bc,0c10h	;byte 0-11 neu setzen
	bit	7,(ix+16+11)	;neuer dateityp mit bit 7?
	jr	z,ncopyp	;nein
	ld	a,'$'
	cp	(ix+9)		;alter dateityp $$$?
	jr	nz,ncopyp
	cp	(ix+10)
	jr	nz,ncopyp
	cp	(ix+11)
	jr	nz,ncopyp
	ld	hl,filero	;nach dir-aenderung fehlermeldung
	push	hl
	ld	hl,copypm	;muster-dir-eintrag fuer copy-protect
	ld	(DEPARM),hl
	ld	bc,2000h	;dir-eintrag komplett neu setzen
ncopyp:	push	bc
	ld	a,(ix)		;fcb[0]
	ld	(ix+16),a	;in 2. filenamen
*EJEC
ie827:	call	ie5f5		;dir-ende?
	jr	z,renend	;ja,fertig
	call	ie544		;test file r/o
	pop	bc
	push	bc
	ld	e,b
	call	ie801		;byte 0-11 neu setzen und schreiben
	call	ie72d		;suchen naechsten dir-eintrag
	jr	ie827
renend:	pop	bc
	ret
copypm:	; ds	20h,0e5h	;so sieht dir nach rename aus
	DFW	0e5e5h 0e5e5h 0e5e5h 0e5e5h
	DFW	0e5e5h 0e5e5h 0e5e5h 0e5e5h
	DFW	0e5e5h 0e5e5h 0e5e5h 0e5e5h
	DFW	0e5e5h 0e5e5h 0e5e5h 0e5e5h
;-----------------------
ie83b:	ld	c,0ch
	call	ie718
ie840:	call	ie5f5
	ret	z
	ld	c,0
	ld	e,0ch
	call	ie801
	call	ie72d
	jr	ie840
;-----------------------
*EJEC
;; open file
FOpen:	ld	c,0fh		;15 bytes vergleichen
	call	ie718		;suchenden dir-eintrag
	call	ie5f5		;gefunden?
	ret	z		;nein
ie85a:	call	ie4a6		;^extentnr.
	ld	a,(hl)
	push	af
	push	hl
	call	ie55e		;^(in dirbuf)
	ex	de,hl		;nach de
	ld	hl,(DEPARM)
	ld	bc,20h
	push	de
	ex	de,hl
	call	FLLDIR		;32 bytes von de nach hl
	ex	de,hl
	call	ie578		;fcb ist aktuell auf dsk.
	pop	de
	ld	hl,000ch
	add	hl,de
	ld	c,(hl)		;extent aus dirbuf
	ld	hl,000fh
	add	hl,de
	ld	b,(hl)		;letzter record im extent
	pop	hl
	pop	af
	ld	(hl),a		;neue extent-nr
	ld	a,c
	cp	(hl)		;gleich?
	ld	a,b
	jr	z,ie88b		;ja, record bleibt
	ld	a,0
	jr	c,ie88b		;neuer extent, leer
	ld	a,80h		;sonst voller extent mit 128 records
ie88b:	ld	hl,(DEPARM)
	ld	de,000fh
	add	hl,de
	ld	(hl),a		;recordzaehler fuer laufenden extent
	ret
;-----------------------
ie894:	ld	a,(hl)
	inc	hl
	or	(hl)
	dec	hl
	ret	nz
	ld	a,(de)
	ld	(hl),a
	inc	de
	inc	hl
	ld	a,(de)
	ld	(hl),a
	dec	de
	dec	hl
	ret
*EJEC
;; Suchen FCB der Datei in Verzeichnis
;
FClose:	xor	a
	ld	(HLPARM),a
	ld	(NMBDIR),a
	ld	(dedeb),a
	call	ROCheck
	ret	nz
	call	ie569
	and	80h		;ist fcb auf diskette aktuell?
	ret	nz		;ja
	ld	c,0fh
	call	ie718
	call	ie5f5
	ret	z
	ld	bc,0010h
	call	ie55e
	add	hl,bc
	ex	de,hl
	ld	hl,(DEPARM)
	add	hl,bc
	ld	c,10h
ie8cd:	ld	a,(BLOCK)
	or	a
	jr	z,ie8e8
	ld	a,(hl)
	or	a
	ld	a,(de)
	jr	nz,ie8db
	ld	(hl),a
ie8db:	or	a
	jr	nz,ie8e1
	ld	a,(hl)
	ld	(de),a
ie8e1:	cp	(hl)
	jr	nz,ie91f
	jr	ie8fd
;-----------------------
*EJEC
ie8e8:	call	ie894
	ex	de,hl
	call	ie894
	ex	de,hl
	ld	a,(de)
	cp	(hl)
	jr	nz,ie91f
	inc	de
	inc	hl
	ld	a,(de)
	cp	(hl)
	jr	nz,ie91f
	dec	c
ie8fd:	inc	de
	inc	hl
	dec	c
	jr	nz,ie8cd
	ld	bc,0ffech
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ld	a,(de)
	cp	(hl)
	jr	c,ie917
	ld	(hl),a
	ld	bc,0003h
	add	hl,bc
	ex	de,hl
	add	hl,bc
	ld	a,(hl)
	ld	(de),a
ie917:	ld	a,0ffh
	ld	(dedd2),a
	jp	ie810
;-----------------------
ie91f:	ld	hl,HLPARM
	dec	(hl)
	ret
*EJEC
;; Erstellen Datei
;
FMake:	call	ie554
	ld	hl,(DEPARM)		;retten nutzer fcb-adr.
	push	hl
	ld	hl,ERASE		;umstellen auf e5-muster
	ld	(DEPARM),hl
	ld	c,01h			;suchen e5-direintrag
	call	ie718
	call	ie5f5
	pop	hl
	ld	(DEPARM),hl		;wiederherstellen fcb-adr.
	ret	z
	ex	de,hl
	ld	hl,000fh
	add	hl,de
	ld	c,11h
	xor	a
ie946:	ld	(hl),a
	inc	hl
	dec	c
	jr	nz,ie946
	ld	hl,000dh
	add	hl,de
	ld	(hl),a
	call	ie58c
	call	ie7fd
	jp	ie578			;fcb ist aktuell auf dsk.
;-----------------------
NextExt:xor	a
	ld	(dedd2),a
	call	FClose
	call	ie5f5
	ret	z
	ld	hl,(DEPARM)
	ld	bc,000ch
	add	hl,bc
	ld	a,(hl)
	inc	a
	and	1fh
	ld	(hl),a
	jr	z,ie983
	ld	b,a
	ld	a,(CEXM)
	and	b
	ld	hl,dedd2
	and	(hl)
	jr	z,ie98e
	jr	ie9ac
;-----------------------
*EJEC
ie983:	ld	bc,0002h
	add	hl,bc
	inc	(hl)
	ld	a,(hl)
	and	0fh
	jr	z,ie9b6
ie98e:	ld	c,0fh
	call	ie718
	call	ie5f5
	jr	nz,ie9ac
	ld	a,(RWMODE)
	inc	a
	jr	z,ie9b6
	call	FMake
	call	ie5f5
	jr	z,ie9b6
	jr	ie9af
;-----------------------
ie9ac:	call	ie85a
ie9af:	call	ie4bb
	xor	a
	jp	ie301
;-----------------------
ie9b6:	call	ie305
	jp	ie578		;fcb ist aktuell auf dsk.
;
;; Eintragung aus Datei lesen
;
SeqRd:	ld	a,01h
	ld	(SRMODE),a
ie9c1:	ld	a,0ffh
	ld	(RWMODE),a
	call	ie4bb
	ld	a,(RECORD)
	ld	hl,COUNTR
	cp	(hl)
	jr	c,ie9e6
	cp	80h
	jr	nz,ie9fb
	call	NextExt
	xor	a
	ld	(RECORD),a
	ld	a,(HLPARM)
	or	a
	jr	nz,ie9fb
ie9e6:	call	SetBl
	call	ie484
	jr	z,ie9fb
	call	BerSNr
	call	ie3d1
	call	Read
	jp	ie4d2
;-----------------------
ie9fb:	jp	ie305
*EJEC
;; Eintragung in Datei schreiben
;
SeqWr:	ld	a,01h
	ld	(SRMODE),a
iea03:	ld	a,0
	ld	(RWMODE),a
	call	ie554 		; Test Disk R/O ?
	ld	hl,(DEPARM)
	call	ie547		; Test File R/O ?
	call	ie4bb
	ld	a,(RECORD)
	cp	80h
	jp	nc,ie305
	call	SetBl
	call	ie484
	ld	c,0
	jr	nz,iea6e
	call	GetDN
	ld	(dedd7),a
	ld	bc,0
	or	a
	jr	z,iea3b
	ld	c,a
	dec	bc
	call	GetBlock
	ld	b,h
	ld	c,l
iea3b:	call	ie7be 		; freien Block suchen
	ld	a,l
	or	h
	jr	nz,iea48 	; --> gefunden
	ld	a,02h
	jp	ie301
;-----------------------
iea48:	ld	(NMBREC),hl
	ex	de,hl
	ld	hl,(DEPARM)
	ld	bc,0010h
	add	hl,bc
	ld	a,(BLOCK)
	or	a
	ld	a,(dedd7)
	jr	z,iea64
	call	ie564
	ld	(hl),e
	jr	iea6c
;-----------------------
*EJEC
iea64:	ld	c,a
	ld	b,0
	add	hl,bc
	add	hl,bc
	ld	(hl),e
	inc	hl
	ld	(hl),d
iea6c:	ld	c,02h
iea6e:	ld	a,(HLPARM)
	or	a
	ret	nz
	push	bc
	call	BerSNr
	ld	a,(SRMODE)
	dec	a
	dec	a
	jr	nz,ieabb
	pop	bc
	push	bc
	ld	a,c
	dec	a
	dec	a
	jr	nz,ieabb
	push	hl
	ld	hl,(ADDIR)
	ld	d,a
iea8c:	ld	(hl),a
	inc	hl
	inc	d
	jp	p,iea8c
	call	ie5e0
	ld	hl,(dede7)
	ld	c,02h
iea9a:	ld	(NMBREC),hl
	push	bc
	call	ie3d1
	pop	bc
	call	Write
	ld	hl,(NMBREC)
	ld	c,0
	ld	a,(CBLM)
	ld	b,a
	and	l
	cp	b
	inc	hl
	jr	nz,iea9a
	pop	hl
	ld	(NMBREC),hl
	call	DMARet
*EJEC
ieabb:	call	ie3d1
	pop	bc
	push	bc
	call	Write
	pop	bc
	ld	a,(RECORD)
	ld	hl,COUNTR
	cp	(hl)
	jr	c,iead2
	ld	(hl),a
	inc	(hl)
	ld	c,02h
iead2:	; nop			;war in fehlerhaften cp/m 2.2:
	; nop			;dec c/ dec c/ jp nz,ieadf
	; ld	hl,0d800h	;3*nop wuerden es auch tun (langsamer)
	push	af
	call	ie569		;adressieren write-flag im fcb
	and	7fh		;fcb bei close auf diskette schreiben
	ld	(hl),a
	pop	af
	cp	7fh
	jr	nz,ieb00
	ld	a,(SRMODE)
	cp	01h
	jr	nz,ieb00
	call	ie4d2
	call	NextExt
	ld	hl,HLPARM
	ld	a,(hl)
	or	a
	jr	nz,ieafe
	dec	a
	ld	(RECORD),a
ieafe:	ld	(hl),0
ieb00:	jp	ie4d2
*EJEC
Rand:	xor	a
	ld	(SRMODE),a
;
;; Vorbereiten CR, EX, S2 fuer Random-Zugriff
;
Rand0:	push	bc
	ld	hl,(DEPARM)
	ex	de,hl
	ld	hl,0021h
	add	hl,de
	ld	a,(hl)
	and	7fh
	push	af
	ld	a,(hl)
	rla
	inc	hl
	ld	a,(hl)
	rla
	and	1fh
	ld	c,a
	ld	a,(hl)
	rra
	rra
	rra
	rra
	and	0fh
	ld	b,a
	pop	af
	inc	hl
	ld	l,(hl)
	inc	l
	dec	l
	ld	l,06h
	jr	nz,Rand4
	ld	hl,0020h
	add	hl,de
	ld	(hl),a
	ld	hl,000ch
	add	hl,de
	ld	a,c
	sub	(hl)
	jr	nz,Rand1
	ld	hl,000eh
	add	hl,de
	ld	a,b
	sub	(hl)
	and	7fh
	jr	z,Rand2
*EJEC
Rand1:	push	bc
	push	de
	call	FClose
	pop	de
	pop	bc
	ld	l,03h
	ld	a,(HLPARM)
	inc	a
	jr	z,Rand3
	ld	hl,000ch
	add	hl,de
	ld	(hl),c
	ld	hl,000eh
	add	hl,de
	ld	(hl),b
	call	FOpen
	ld	a,(HLPARM)
	inc	a
	jr	nz,Rand2
	pop	bc
	push	bc
	ld	l,04h
	inc	c
	jr	z,Rand3
	call	FMake
	ld	l,05h
	ld	a,(HLPARM)
	inc	a
	jr	z,Rand3
Rand2:	pop	bc
	xor	a
	jp	ie301
;-----------------------
Rand3:	push	hl
	call	ie569
	ld	(hl),0c0h	;fcb bei close nicht auf dsk.
	pop	hl
Rand4:	pop	bc
	ld	a,l
	ld	(HLPARM),a
	jp	ie578		;fcb ist aktuell auf dsk.
;
;; Random read
;
ieb93:	ld	c,0ffh
	call	Rand
	call	z,ie9c1
	ret
*EJEC
;; Random write
;
ieb9c:	ld	c,0
	call	Rand
	call	z,iea03
	ret
;-----------------------
GetSiz:	ex	de,hl
	add	hl,de
	ld	c,(hl)
	ld	b,0
	ld	hl,000ch
	add	hl,de
	ld	a,(hl)
	rrca
	and	80h
	add	a,c
	ld	c,a
	ld	a,0
	adc	a,b
	ld	b,a
	ld	a,(hl)
	rrca
	and	0fh
	add	a,b
	ld	b,a
	ld	hl,000eh
	add	hl,de
	ld	a,(hl)
	add	a,a
	add	a,a
	add	a,a
	add	a,a
	push	af
	add	a,b
	ld	b,a
	push	af
	pop	hl
	ld	a,l
	pop	hl
	or	l
	and	01h
	ret
;-----------------------
*EJEC
FSize:	ld	c,0ch
	call	ie718
	ld	hl,(DEPARM)
	ld	de,0021h
	add	hl,de
	push	hl
	ld	(hl),d
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),d
iebe4:	call	ie5f5
	jr	z,iec0c
	call	ie55e
	ld	de,000fh
	call	GetSiz
	pop	hl
	push	hl
	ld	e,a
	ld	a,c
	sub	(hl)
	inc	hl
	ld	a,b
	sbc	a,(hl)
	inc	hl
	ld	a,e
	sbc	a,(hl)
	jr	c,iec06
	ld	(hl),e
	dec	hl
	ld	(hl),b
	dec	hl
	ld	(hl),c
iec06:	call	ie72d
	jr	iebe4
;-----------------------
iec0c:	pop	hl
	ret
;
;; Funktion 36 - Set random record
;
SETRAND:ld	hl,(DEPARM)
	ld	de,0020h
	call	GetSiz
	ld	hl,0021h
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	inc	hl
	ld	(hl),a
	ret
;-----------------------
*EJEC
iec21:	ld	hl,(LOGVEKT)
	ld	a,(CURRD)
	ld	c,a
	call	ie4ea
	push	hl
	ex	de,hl
	call	Prepar 	 	; Zero = Fehler
	pop	hl
	call	z,ie347 	; Aufruf bei Fehler (BASIC: Rueckkehr aus BDOS
				;		     SCPX:  Warmstart)
	ld	a,l
	rra
	ret	c
	ld	hl,(LOGVEKT)
	ld	c,l
	ld	b,h
	call	ie50b
	ld	(LOGVEKT),hl
	jp	Scan
;
;; Funktion 14 - Select disk
;
SETDSK:	ld	a,0ffh		;***loeschen keller standlaufw.***
	ld	(OLDDISK),a
iec45:	ld	a,(ENTBYTE)	;auszuwaehlendes lw
	ld	hl,CURRD
	cp	(hl)		;gleich zuletzt ausgewaehltem?
	ret	z		;ja, parameter nicht neu uebernehmen
	ld	(hl),a
	jr	iec21
;-----------------------
iec51:	ld	a,0ffh
	ld	(IFDISK),a
	ld	hl,(DEPARM)
	ld	a,(hl)
	and	1fh		;'?' zulassen auf lw-position!
	dec	a
	cp	1eh
	jp	c,ncurd		;***nicht 00h oder 1fh
	ld	hl,OLDDISK	;***setzen standard-laufwerk***
	ld	a,(hl)
	inc	a		;keller leer?
	jr	z,iec75		;ja
	ld	(hl),0ffh	;anzeigen keller leer
	dec	a		;standard laufwerk
	ld	(ENTBYTE),a	;auf paramfeld fuer seldsk
	call	iec45		;seldsk
	jr	iec75
*EJEC
ncurd:				;***retten standardlaufwerk***
	ld	(ENTBYTE),a	;param fuer seldsk hinterl.
	ld	a,(OLDDISK)	;keller curdsk
	inc	a		;keller leer?
	jr	nz,ncurd1	;nein
	ld	a,(CURRD)	;current disk
	ld	(OLDDISK),a	;einkellern
ncurd1:	ld	a,(hl)		;fcb[0] merken
	ld	(FCB_0),a
	and	0e0h
	ld	(hl),a		;und bit 4-0 loeschen
	call	iec45		;seldsk
iec75:	ld	a,(USER)
	ld	hl,(DEPARM)
	or	(hl)
	ld	(hl),a
	ret
;
;; Funktion 12 - Return version number
;
iec7e:
VERSNM:	ld	a,22h
	jp	ie301
*EJEC
;; Funktion 13 - Reset disk system
;
RESDSK:				;***loeschen keller standlaufw.***
	ld	a,0ffh		;anzeigen keller leer
	ld	(OLDDISK),a
	ld	hl,0	
	ld	(ROVEKT),hl	;ruecksetzen login und r/o
	ld	(LOGVEKT),hl
	ld	hl,SYSDV
	ld	a,(hl)		;system-lw schon definiert?
	cp	0ffh
	jr	nz,resdk1	;ja, auf dieses umschalten
;
	IN	A,(PPIA)
	LD	B,A		; Retten Speicherbelegung
	AND	0FCh
	OR	2		;page0/slot2 zuschalten
	OUT	(PPIA),A
	ld	a,(defaul)	;sonst erstes default benutzen
	and	0fh
	LD	C,A		; Retten akt. Laufwerk
	LD	A,B
	OUT	(PPIA),A	; gerettete Speicherbelegung
	LD	A,C
	ld	(hl),a
;
resdk1:	ld	(CURRD),a	;als current disk
	ld	(HLPARM+1),a	;und als h in BDOS-result
	ld	hl,(STDDMA)	;set dma auf standard
	ld	(DMAADD),hl
	call	DMARet
	jp	iec21		;disk parameter uebernehmen
;
;; Funktion 15 -  Open file
;
OPEN:	call	ie572		;loeschen fcb[14] (write-flag)
	call	iec51		;lw selektieren
	jp	FOpen
*EJEC
;; Funktion 16 - Close file
;
CLOSE:	call	iec51
	jp	FClose
;
;; Funktion 17 - Search for first
;
FIRST:	ld	c,0
	ex	de,hl
	ld	a,(hl)
	cp	'?'
	jr	z,iecc2
	call	ie4a6 		; <hl> := fcb[12] = ex
	ld	a,(hl)
	cp	'?'
	call	nz,ie572	;fcb[14]:=0
	call	iec51
	ld	c,0fh
iecc2:	call	ie718
	jp	ie5e9
;
;; Funktion 18 - Search for next
;
NEXT:	ld	hl,(ENTFCB)
	ld	(DEPARM),hl
	call	iec51
	call	ie72d
	jp	ie5e9
;
;; Funktion 19 - Delete file
;
DELETE:	call	iec51
	call	EraFil
	jp	ie701
;
;; Funktion 20 - Read sequentiell
;
SEQREAD:	call	iec51
	jp	SeqRd
;
;; Funktion 21 - Write sequentiell
;
SEQWRITE:	call	iec51
	jp	SeqWr
*EJEC
;; Funktion 22 - Make file
;
MAKEF:	call	ie572		;fcb[14]:=0
	call	iec51
	jp	FMake
;
;; Funktion 23 - Rename file
;
RENAME:	call	iec51
	call	FRen
	jp	ie701
;
;; Funktion 24 - Return login vektor
;
LOGIN:	ld	hl,(LOGVEKT)
	jp	ied29
;
;; Funktion 25 - Return current disk
;
CURRENT:ld	a,(OLDDISK)	;***holen standardlaufw.***
	inc	a		;keller leer?
	jr	z,cursff	;ja
	dec	a
	jp	ie301
cursff:	ld	a,(CURRD)
	jp	ie301
;
;; Funktion 26 - Set DMA address
;
SETDMA:	ex	de,hl
	ld	(DMAADD),hl
	jp	DMARet
;
;; Funktion 27 - Get address allocation vector
;
GETALLOC:	ld	hl,(ADALLOC)
	jp	ied29
;
;; Funktion 29 - Get r/o vektor
;
GETPRO:	ld	hl,(ROVEKT)
	jp	ied29
;
;; Funktion 30 - Set file attributes
;
SETATTR:	call	iec51
	call	ie83b
	jp	ie701
*EJEC
;; Funktion 31 - Get address disk parameter
;
GETDPB:	ld	hl,(ADDPB)
ied29:	ld	(HLPARM),hl
	ret
;
;; Funktion 32 - Set/Get USER code
;
SGUSER:	ld	a,(ENTBYTE)
	cp	0ffh
	jr	nz,ied3b
	ld	a,(USER)
	jp	ie301
ied3b:	and	1fh
	ld	(USER),a
	ret
;
;; Funktion 33 - Read random
;
RANDRD:	call	iec51
	jp	ieb93
;
;; Funktion 34 - Write random
;
RANDWR:	call	iec51
	jp	ieb9c
;
;; Funktion 35 - Compute file size
;
FSIZE:	call	iec51
	jp	FSize
;-----------------------
;; selektives reset fuer lw'e entsprechend bitliste in de
;
RESDRIV:ld	hl,(DEPARM)
	push	hl
	call	ie521		;ist aktuell selektiertes lw dabei?
	jr	z,selrs1	;nein
	cpl			;auf fe
	ld	(CURRD),a	;aktuell selektiertes lw ungueltig
*EJEC
selrs1:	pop	hl
	ld	a,l
	cpl
	ld	e,a
	ld	a,h
	cpl
	ld	hl,(LOGVEKT)	;login-vektor
	and	h
	ld	d,a
	ld	a,l
	and	e
	ld	e,a
	ld	hl,(ROVEKT)	;r/o-vektor
	ex	de,hl
	ld	(LOGVEKT),hl	;ruecksetzen login-vektor
	ld	a,l
	and	e
	ld	l,a
	ld	a,h
	and	d
	ld	h,a
	ld	(ROVEKT),hl	;ruecksetzen r/o
	ret
;-----------------------
WRINIT:	call	iec51
	ld	a,02h
	ld	(SRMODE),a
	ld	c,0
	call	Rand0
	call	z,iea03
	ret
 
; -------------- Ende BDOS.ROM.S ------------------
