;**********************************************
;
;Logischer Floppy-Treiber fuer BIC
;Filename: BICDITR.S
;Version Dr. Dames 1.2.88, Anpassung an phys. SCP1715-Schnittstelle
;
;STAND: 02.05.89 / Ludewig
;**********************************************
;
;Makro DFB im Modul BIC.MAC.S erforderlich !
;
	GLOBAL	SELDSK	HOME	SETTRK	SETSEC	BSETDMA
	GLOBAL	SECTRAN	 WRITE	READ	BFLINI
	GLOBAL	MRECOA	MRECOL	DIORTY
	GLOBAL	BV24W1	BIOSM0	BIO10
;
	EXTERNAL	RDRIPU	OUTASC
;**********************************************
;
;Vereinbarungen fuer Varianten
;==============================================
DSKDS	EQU	1	;Unterstuetzung zweiseitiger LW
DSK80	EQU	1	;Unterstuetzung 80-spuriger LW
ENWRIT	EQU	1	;Schreiben auf Disk unterstuetzt
DBUFSZ	EQU	10	;Puffergroesse = 1024
AUTFER	EQU	1	;Unterstuetzung autom. Formaterkennug
IBMFRM	EQU	AUTFER	;Unterstuetzung IBM-Format von SIOS
ERRVAR	EQU	1	;mit BIOS-Fehlermeldg bei Floppy-Fehler
;**********************************************
LORIPU	EQU	156H	;Loe. Ringpuffer
KOMSCR	EQU	174H	;Kommando-SCREEN
;
PPIA	EQU	0A8H	;Bankumschaltung
;**********************************************
*E
LFPANF:
;	Diskettentreiber; Umkleidung des phys. Transfers
;	Version Dr. Dames 01.02.88
; Aenderungen
; - Anpassung an SCP1715-Schnittstelle fuer phys. Floppymodul
; - Abbildung mehrerer log. LW auf gleiches phys. LW unterstuetzt
;
;**********************************************
;
; Laufwerksauswahl
;==============================================
; i C: Laufw. (0=A:, 1=B: ...)
; i E: Bit 0 ist LOGIN-Bit von BDOS (=0, wenn LOGIN)
;
SELDSK:	CALL	DGETPB		;HL auf DPH stellen, IX auf DPB
	RET	Z		;Geraet ex. nicht
	LD	A,C
	LD	(DUDEV),A	;Laufwerk merken
	BIT	0,E		;LOGIN von BDOS?
	RET	NZ		; nein-->
;==============================================
	BIT	DPBFND,(IX+DPBFLG) ;Diskette?
	RET	NZ		   ; nein:fertig
;----------------------------------------------
	PUSH	HL		;^DPH merken
	COND	DBUFSZ.GT.7
	LD	HL,DBDEV
	CP	(HL)		;LOGIN fuer gepuffertes Device?
	JR	NZ,DSELNB	; nein-->
;----------------------------------------------
	LD	(HL),0FFH	;Puffer ist ungueltig
	LD	HL,DBFLG
	RES	DBFWR,(HL)	;kein veraend. Puffer auszug.!
DSELNB:	ENDC
;==============================================
	COND	AUTFER
;++++++++++Automatische Format-Erkennung++++++++++
; Reg. C zeigt auf Laufwerk
	BIT	DPBFRM,(IX+DPBFLG) ;Formaterkennung unterdr.?
	JP	NZ,SELEXT	    ; ja-->
	ENDC
;----------------------------------------------
	COND	(DBUFSZ.GT.7).AND.AUTFER
	CALL	DBTRW		;Puffer freimachen und auf Lesen schalten 	## (0) ##
	LD	HL,DBNB
	LD	(HL),0FFH	;Puffernummer ist ungueltig, obwohl evtl.
				;alle anderen Pufferparameter stimmen
				;(da nur 128 Bytes vom Puffer belegt sind)
	ENDC
;	---------------------------------------
	COND	AUTFER
	LD	A,C
	LD	(DFRDEV),A
	LD	(DBDEV),A
;	------------------------
	XOR	A
	LD	(IX+DPBFLG),A	;ruecksetzen alle Flags
	LD	(IX+DPBSN0),A	;keine Weiter-Numm. auf Ruecks.
	LD	(IX+DPBOFS),A	;keine Systemspuren
	LD	(DFRTRK),A	;Spur 0
	LD	(DBTRK),A
;	------------------------
	INC	A
	LD	(DBSEC),A	;Sektor 1
	LD	(DBSNB),A	;1 phys. Sektor lesen
;	---------------------------------------
	PUSH	IX		;Stellen  Sektor-Translate-Tabelle 1,2,3,...
	LD	B,26		;max. Laenge der Tabelle
SELSTZ:	LD	(IX+DPBSTR),A
	INC	IX
	INC	A
	DJNZ	SELSTZ
	POP	IX
;==============================================
; Positionieren auf Spur 0 und analysieren Systemspuren
;
	CALL	DSIDTR		;beliebigen Sekt.Id lesen			## 1 ##
	JR	NZ,SELSYS	;Fehler beim Lesen-->Systemsp. annehmen
				;(z.B. SCP1700 mit 5"FM in Spur 0!!)
	LD	A,H
	LD	(DBSLC),A	;setzen Spurformat fuer Sp. 0
	ENDC
;	---------------------------------------
	COND	(DBUFSZ.LT.8).AND.AUTFER
	OR	A		;Sektorlaenge 128?
	JR	NZ,SELSYS	; nein:Puffer zu klein - Systemspuren annehmen
	ENDC
;	---------------------------------------
	COND	AUTFER
	LD	HL,DBFLG
	LD	B,(HL)		;merken Fehlerprotokoll-Bit
	SET	DBFTR,(HL)	;kein Fehlerprotokoll
	PUSH	HL
	CALL	DBTRAN		;Lesen Spur 0, Sektor 1	 			## 2 ##
	POP	HL
	LD	(HL),B		;setzen Standard fuer Fehlerprotokoll-Bit
	JR	NZ,SELSYS	;Fehler, Systemspuren annehmen
;	---------------------------------------
	PUSH	IY
	LD	IY,(DBDMA)
	LD	A,(IY+0)	;Format-Loeschbyte
	CP	0E5H		;leere Diskette/geloeschter Eintrag?
	JR	NZ,SELSY2	; nein (weder/noch)-->
;	------------------------
	CP	(IY+1)		;auch danach 0e5h?
	JR	NZ,SELSY0	; nein:geloeschter Dir-Eintrag
;	------------------------
	DEC	(IX+DPBOFS)	;Flag: leere Disk oder leere Systemsp.
	JR	SELSY0		; dpbofs auf 254
;	---------------------------------------
SELSY2:	ENDC
	COND	IBMFRM.AND.AUTFER
	CP	40H		;IBM-Format (SIOS-Daten-Diskette)?
	JR	Z,SELSY1	; ja:0 Systemspuren annehmen
	ENDC
;	------------------------
	COND	AUTFER
	CP	20H		;<=31 ? ("S"YL ist groesser!)
	JR	NC,SELSY1	; nein:kann kein Directory sein; 0 Systemsp.
				; (Systemlader fuer PC1715 beginnt mit 02 oder 03)
;	------------------------
	LD	A,(IY+20H)	;bei SCP1715-Systemdiskette dort 00h
				;bei MicroDos dort 10h
	OR	(IY+21H)	;bei SCP1715-Systemdiskette dort 00h
				;bei CP/A dort Dir-Eintrag (E5 oder Filename)
	JR	Z,SELSY1	;beides 00h, kein Directory; 0 Systemsp.
;	------------------------
SELSY0:	DEC	(IX+DPBOFS)	;=255, wenn Directory/ =254 wenn vorn leer
;	------------------------ =0, wenn Systemspuren
SELSY1:	POP	IY
SELSYS:
;==============================================
; Analysieren Datenspur
; SS/DS-Analyse
;
	LD	(IX+DPBSTP),2	;Doppel-Step-Impulse
;	------------------------
	LD	A,DLGINT	;auf LOGIN-Spur (Behandlung einseitig: Spur 3)
	CALL	DSIDTT		; belieb. SektId Vorderseite lesen		## 3 ##
	JR	NZ,SELDLE	;Fehler-->unsicheres Format
	LD	D,H		;d:=Sektorlcode, e:=Spur
	ENDC
	COND	DSKDS.AND.AUTFER
	BIT	DPBTDS,(IX+DPBDRT) ;ist es ein DS-Laufwerk?
	JR	Z,SELSS		   ; nein:SS
;	------------------------
	PUSH	DE		;merken Sektorlaengencode und Spur
	SET	DPBFDS,(IX+DPBFLG) ; (Behandlung zweiseitig: Spur 7)
	LD	A,1+(DLGINT*2)	;Rueckseite der Spur,
				; ab der Format bei SS konstant
	CALL	DSIDTT		;beliebigen Sekt.Id Ruecks. lesen		## 4 ##
	LD	A,D		;merken side Ruecks. ------------------> Auswertung ????
	LD	L,E		;h:=Sektorlcode, l:=Spur Rueckseite
	POP	DE		;wiederherstellen Vorderseite
	JR	NZ,SELSS	;Fehler beim Lesen:SS
;	------------------------
	OR	A
	SBC	HL,DE		;Vorder- gleich Rueckseite?
	JR	Z,SEL48
;	------------------------
SELSS:	RES	DPBFDS,(IX+DPBFLG) ; nein:einseitig
	ENDC
;==============================================
	COND	AUTFER
; 40/80 Track Analyse
;
SEL48:	LD	A,E		;trk
	SUB	DLGINT		;waren 2 Steps richtig?
	JR	Z,SELDL1	; ja-->
	DEC	(IX+DPBSTP)	;Einzelstep-Impulse
	SUB	DLGINT		;waere 1 Step richtig?
	JR	Z,SELDL1	; ja-->
				; nein:unsicher
;==============================================
; Fehlerausgang automat. Formaterkennung
;
SELDLE:	LD	(IX+DPBSLC),0FFH;provozieren 'BAD SECTOR'
	LD	HL,0		;erzeugen 'SELECT' Error
	EX	(SP),HL	 	;^DPH=0 (im Stack)
	JP	SELEX5
;==============================================
; DS/SS und 40/80 ist unterschieden, es fehlt Sektorlaenge
;
SELDL1:	LD	A,D
	LD	(IX+DPBSLC),A	;definieren Sektorlaengencode
	ENDC
;	------------------------
	COND	(DBUFSZ.LT.8).AND.AUTFER
	OR	A		;Sektorlaenge 128?
	JR	NZ,SELDLE	;nein, Puffer reicht nicht
	ENDC
;	------------------------	
;Test, ob Disk-Puffer ausreicht
	COND	((DBUFSZ.LT.10).AND.(.NOT.(DBUFSZ.LT.8))).AND.AUTFER
	CP	DBUFSZ-6	;dpbslc < dbufsz-6?
	JR	NC,SELDLE	;nein, zu klein
	ENDC
;	---------------------------------------
	COND	(.NOT.(DBUFSZ.LT.8)).AND.AUTFER
	OR	A		;Sektorlaenge 128?
	JR	NZ,SELDXL	;nein, normale Sektorfolge
	ENDC
;	------------------------
	COND	AUTFER
; Stellen Sektor-Translate-Tabelle 1,7,13,..
	PUSH	IX
	POP	HL
	LD	BC,DPBSTR
	ADD	HL,BC
	EX	DE,HL
	LD	HL,XLT
	LD	C,26
	LDIR
;	---------------------------------------
SELDXL:
	CALL	DTRSLA		;stellen hl entspr. Sektorlaenge
	JR	NZ,SELDLE	; unzulaessig-->
;	------------------------
	LD	BC,DSLL		;Laenge eines Eintrags
	BIT	1,(IX+DPBSTP)	;40 Tr. auf 80er LW?
	JR	NZ,SELD40	; ja-->
;	------------------------
	LD	A,(IX+DPBPTR)	;40er LW?
	CP	40+1
	JR	C,SELD40	; ja:40 Tr. auf 40er LW-->
;	------------------------
	ADD	HL,BC		;auf 80er Format stellen
SELD40:	BIT	DPBFDS,(IX+DPBFLG) ;DS?
	JR	Z,SELDSS	   ; nein-->
;	------------------------
	ADD	HL,BC		;auf DS Format
	ADD	HL,BC
SELDSS:
;===============================================
; DPB modifizieren entsprechend erkanntem Format
;
	LD	C,(HL)		;Zahl der benutzten Spuren
	LD	(IX+DPBTRK),C
	INC	HL
	LD	C,(HL)		;Anzahl 128er Sektoren pro Spur
	LD	(IX+DPBSPT),C
	INC	HL
	LD	C,(HL)		;Anzahl der Dir-Eintraege -1
;----------------------------------------------
	INC	HL
	LD	A,(HL)		;Anzahl der Systemspuren
	SRL	A		;feste Anzahl erzwungen?
	JR	C,SELDOF	; ja-->
;	------------------------
	BIT	7,(IX+DPBOFS)	;kann Spur 0 Directory sein?
	JR	Z,SELDOF	; nein:Standardanzahl setzen
;	---------------------------------------
	INC	(IX+DPBOFS)	;evtl. leere Systemspur?
	JR	NZ,SELDOF	; ja: Vorzugsweise 190K, 380K, 390K, 780K
;	------------------------
;
;	LD	B,A		;retten Anzahl Systemspuren
;	LD	(DBTRK),A	;einlesen evtl. moeglicher Datenbeginn
;	PUSH	HL
;	CALL	DBTRAN		;dauert bei falscher Spur etwas laenger 	## (5) ##
;	POP	HL
;	LD	A,B
;	JR	NZ,SELDOF	;Fehler, mit Systemspuren annehmen
;	------------------------
;	LD	DE,(DBDMA)
;	INC	DE		;!!!! Korr., wenn 1.Datei geloescht !!!!
;	LD	A,(DE)
;	CP	0E5H		;Daten auch leer?
;	LD	A,B
;	JR	NZ,SELDOF	; nein:vorn liegen nichtbelegte Systemspuren
;
;	------------------------
SELDO0:	XOR	A		;sonst ohne Systemspuren
;	------------------------
SELDOF:	LD	(IX+DPBOFS),A
;----------------------------------------------
	OR	A		;0 Systemspuren?
	JR	Z,SELDDR	; ja-->
;	------------------------
	LD	A,C		;Anzahl Dir-Eintraege<192 ?
	CP	192-1
	JR	C,SELDDR	; ja-->
;	------------------------
	LD	C,128-1		; nein(780k): 128 Dir-Eintraege
;	------------------------
SELDDR:	LD	(IX+DPBDIR),C
;----------------------------------------------
	INC	HL
	LD	C,(HL)		;Abstand der Blockgroessentab.
	LD	B,0
	ADD	HL,BC		;HL=Zeiger auf Blockgroessentabelle
;	------------------------
	LD	C,(HL)
	LD	(IX+DPBBLS),C
	INC	HL
	LD	C,(HL)
	LD	(IX+DPBBLM),C
	INC	HL
	LD	C,(HL)
	LD	(IX+DPBEXM),C
;==============================================
; Bestimmen Zahl der abweichenden 128er-Spuren (ab Spur 0)
;
	XOR	A
	LD	(DFRTRK),A	;ab Spur 0
		;(gleichz. Spurkorr. bei falschen Doppelstepimpulsen)
;	------------------------
SF128Z:	CALL	DSIDTR		;beliebigen SektId lesen			## 6- ##
	JR	NZ,SF128E	; Fehler-->
;	------------------------
	LD	A,H		;Sektorlaenge
	CP	(IX+DPBSLC)	; gleich Disketten-Rest?
	JR	Z,SF128E	; ja-->WEITER
;	------------------------
	LD	A,(IX+DPBFLG)
	AND	DPBFSM		;bisherige Anzahl abweichender Spuren
	CP	DPBFSM		;Zaehler voll?
	JR	Z,SF128E	; ja-->
;	------------------------
	INC	(IX+DPBFLG)	;erhoehen abweich. Spurzahl
	LD	HL,DFRTRK	;naechste (logische!) Spur
	INC	(HL)
	JR	SF128Z
;----------------------------------------------
SF128E:	ENDC
;==============================================
	COND	(DBUFSZ.GT.7).AND.AUTFER
; Setzen Anzahl der logischen 128er Rekords im Puffer -1
; Es wird immer das Maximum gesetzt, dies setzt eine dichte
; Sektorfolge beim Transfer voraus! (so in dpbstr)
;
	LD	(IX+DPBBFM),+(1.SHL.(DBUFSZ-7))-1
	ENDC
;----------------------------------------------
	COND	AUTFER
; Berechnen Speicherkapazitaet-1 in BDOS-Bloecken aus
; ((Tracks-dpbofs)*dpbspt/(2**dpbbls))-1
;
	LD	L,(IX+DPBTRK)
	XOR	A
	LD	H,A		;hl:=log. Spurzahl
	LD	E,(IX+DPBOFS)
	LD	D,A		;de:=log. offset-Spurzahl
	SBC	HL,DE
	EX	DE,HL		;de:=log. Daten-Spurzahl
	LD	L,A		;hl:=0
	LD	B,(IX+DPBSPT)
DSIZMZ:	ADD	HL,DE
	DJNZ	DSIZMZ		;hl:=(tracks-dpbofs)*dpbspt
DSIZME:	LD	B,(IX+DPBBLS)
DSIZDZ:	SRL	H
	RR	L
	DJNZ	DSIZDZ		;hl:=hl/2**dpbbls
	DEC	HL		;hl:=hl-1
	LD	(IX+DPBSIZ),L
	LD	(IX+DPBSIZ+1),H
;	------------------------
	LD	A,(IX+DPBDIR)	;Dir-Groesse
	INC	A
	RRCA
	RRCA			; div 4( da 4 Dir-Eintr./Sekt.)
	LD	(IX+DPBCHK),A	; ist Sektorzahl = Check size
;	------------------------
	LD	B,(IX+DPBBLS)	;block shift
SELDLA:	RRCA			;BDOS-Bloecke fuer Dir.
	DJNZ	SELDLA
	LD	B,A
	XOR	A
SELDAL:	SCF			;Allocation-Bits fuer Dir.
	RRA
	DJNZ	SELDAL
	LD	(IX+DPBALC),A
;+++++++++++Ende automatische Formaterkennung+++++++++++++
	ENDC
;==============================================
SELEXT:
; Anzeigen Diskformat als Speicherkapazitaet in kBytes
	LD	A,(DUDEV)
	ADD	A,'A'
	LD	BC,DISKA5
	LD	(BC),A		;LW
	INC	BC
	INC	BC
;	------------------------
; (dpbsiz+1)*(2**(dpbbls-3))
	LD	L,(IX+DPBSIZ)
	LD	H,(IX+DPBSIZ+1)
	INC	HL
	LD	A,(IX+DPBBLS)
	SUB	3
	JR	Z,SELEX1
SELEX2:	ADD	HL,HL
	DEC	A
	JR	NZ,SELEX2
;	------------------------
SELEX1:	LD	DE,100		;immer dreistellig
	CALL	DEZWA
	LD	DE,10
	CALL	DEZWA
	LD	A,L
	OR	'0'
	LD	(BC),A
;	------------------------
	LD	HL,DISKAP	;fuer RBASIC
	CALL	XSELE
;==============================================
SELEX5	POP	HL		;hl auf DPH
	RET			;Return Seldsk
;==============================================
DEZWA	XOR	A	
DEZW1	AND	A
	SBC	HL,DE
	JR	C,DEZW2
	INC	A
	JR	DEZW1
;	------------------------
DEZW2	ADD	HL,DE
	ADD	A,'0'
	LD	(BC),A
	INC	BC
	RET
;**********************************************
;
; auf Spur 0 zurueck (vor jedem Dir-Zugriff)
;==============================================
HOME:	COND	DBUFSZ.GT.7
	LD	HL,DBFLG
	BIT	DBFWR,(HL)	;veraenderter Puffer?
	JR	NZ,HOM10	;ja, nicht freigeben
;	------------------------
	LD	A,0FFH		;sonst Diskwechsel erlauben
	LD	(DBDEV),A	;Puffer ist nicht aktiv
	ENDC
;	------------------------
HOM10:	LD	C,0
;**********************************************
;
; Einstellen Spur in Reg. BC
;==============================================
SETTRK	LD	A,C
	LD	(DUTRK),A	;Spur merken
	RET
;**********************************************
;
; Einstellen Sektor in Reg. C
;==============================================
SETSEC:	LD	A,C
	LD	(DUSEC),A
	RET
;**********************************************
;
; Einstellen DMA in Reg. BC
;==============================================
BSETDMA	LD	(DUDMA),BC
	RET
;**********************************************
;
; Uebersetzung Sektornummer
;==============================================
; Translate-Tab-Adr. in DE, Eingangs-Sektornummer in BC,
;			    Ausgangs-Sektornummer in HL
; Es wird keine Translate-Tabelle benutzt, da die Sektor-
; nummernverwaltung verallgemeinert im nicht-Standard-DPB
; enthalten ist (auch fuer physische Sektorlaenge <>128)
;
SECTRAN:LD	H,B
	LD	L,C
	INC	HL	;Sektoren zaehlen in CP/A ab 1
	RET
;************************************************
;
; Schreiben Sektor
;==============================================
; Register C (vom BDOS gestellt):
;	=0, wenn normales write
;	=1, wenn directory-write (sofort ausgeben)
;	=2, wenn Beginn eines neuen Datenblocks (kein preread)
;
	COND	ENWRIT
WRITE:	LD	E,C		;retten Reg. C
	LD	A,(DUDEV)
	LD	C,A
	CALL	DGETPB		;ix:=dpb(ddrive)
	JR	Z,DRWERR	;Geraet ex. nicht
	ENDC
;	------------------------
	COND	ENWRIT
	BIT	DPBFND,(IX+DPBFLG) ;Diskette?
	JP	NZ,XWRRAF	   ; nein
;----------------------------------------------
	LD	HL,DUFLG
	SET	DUFWR,(HL)	;Write-Flag setzen
	ENDC
;	------------------------
	COND	(DBUFSZ.GT.7).AND.ENWRIT ;gepufferte Disk E/A
	LD	HL,DBFLG
	SET	DBF00,(HL)	;Annahme preread notwendig
;	---------------------------------------
	LD	A,E		;A:= Write-Typ
	LD	(DWRTYP),A	;merken Write-Typ
	CP	2		;write to unallocated?
	JR	NZ,CHKUNA	; nein-->
;	------------------------
	LD	A,(IX+DPBBLM)	;Zahl der 128-Sekt. im Block -1
	INC	A
	LD	(UNACNT),A	;fuer diese Sekt. kein preread
	LD	HL,UNADEV
	LD	(HL),C
	LD	A,(DUTRK)
	LD	(UNATRK),A
	LD	A,(DUSEC)
	LD	(UNASEC),A
;	---------------------------------------
CHKUNA:	LD	HL,UNACNT
	LD	A,(HL)
	OR	A		;noch nicht geschr. Sekt. da?
	JR	Z,ALLOC		; nein-->
;	------------------------
	DEC	A		;sonst Restzahl -1
	LD	(HL),A
	INC	HL
	LD	A,C
	CP	(HL)		;gleiches Geraet?
	JR	NZ,ALLOC	; nein
;	------------------------
	INC	HL
	LD	A,(DUTRK)
	CP	(HL)		;gleiche Spur?
	JR	NZ,ALLOC	; nein
;	------------------------
	INC	HL
	LD	A,(DUSEC)
	CP	(HL)		;gleicher Sektor?
	JR	NZ,ALLOC	; nein
;	---------------------------------------
; Vorbereiten naechsten unalloc write-Aufruf
	CP	(IX+DPBSPT)	;neue Spur?
	JR	C,UNATR1	; nein
;	------------------------
	DEC	HL
	INC	(HL)		;unatrk +1
	INC	HL
	XOR	A		;Sektor auf Spuranfang
;	------------------------
UNATR1:	INC	A		;naechster Sektor
	LD	(HL),A
;	---------------------------------------
	LD	HL,DBFLG
	RES	DBF00,(HL)	;anzeigen kein preread notw.
	ENDC
	COND	ENWRIT
	JR	DRW
	ENDC
;**********************************************
;
; Abbruch read/write mit E/A-Fehler
;==============================================
DRWERR:	LD	A,1
	RET
;**********************************************
;
; Lesen Sektor
;==============================================
;
READ:	LD	A,(DUDEV)
	LD	C,A
	CALL	DGETPB		;ix:=dpb(ddrive)
	JR	Z,DRWERR	;Geraet ex. nicht
;	------------------------
	BIT	DPBFND,(IX+DPBFLG)	;Diskette?
	JP	NZ,XRDRAF	;nein
;----------------------------------------------
	LD	HL,DUFLG
	RES	DUFWR,(HL)	;Lesen anzeigen
;	------------------------
	COND	DBUFSZ.GT.7
	LD	HL,DBFLG
	SET	DBF00,(HL)	;preread notwendig
	LD	A,2
	LD	(DWRTYP),A
	ENDC
;==============================================
ALLOC:
	COND	(DBUFSZ.GT.7).AND.ENWRIT
	XOR	A
	LD	(UNACNT),A	;Ende unalloc
	ENDC
;**********************************************
;
; gemeinsamer Zweig read/write Floppy
;==============================================
;
DRW:	LD	A,(DUSEC)	;Sektornummer in 1..dpbspt
	DEC	A		; ab 0 zaehlen
	JP	M,DRWERR	; <0:Fehler
;	------------------------
	CP	(IX+DPBSPT)	;Sektornr<dpbspt?
	JR	NC,DRWERR	; nein:Fehler
;	---------------------------------------
	COND	DBUFSZ.GT.7
	LD	B,A		;retten dsectr-1
	ENDC
;	---------------------------------------
	LD	A,(IX+DPBFLG)
	AND	DPBFSM		;Anzahl der abweich. 128er Spuren
	LD	D,A
	LD	A,(DUTRK)	;verlangte Spur
	CP	D		; im abweichenden Spurformat?
	JP	C,DRWSEC	; ja:Sektorlaenge 128				## 1" ##
;	------------------------
				;gepufferte Disk E/A
	COND	(DBUFSZ.GT.7).AND.(DBUFSZ.LT.12);<2**12 =4K Puffer
	LD	A,(IX+DPBSLC)	;phys. Sektorlaenge 128
	OR	A		; (d.h. mit Sektorversatz)?
	JP	Z,DRWSEC	; Ja:keine Pufferung sinnvoll			## 1"" ##
	ENDC
;----------------------------------------------
	COND	DBUFSZ.GT.7
	LD	A,B
	LD	D,(IX+DPBBFM)	;Puffermaske
	AND	D		;rel. Sekt.nr. des BDOS-Blocks zum Puff.anf.
	PUSH	AF		; merken fuer move
	XOR	B		;A ist Sektornr. des Puff.anf.
DRWBNR:	SRL	A		;ermitteln Puffernr in Spur
	RR	D		;noch Bits in Puffermaske?
	JR	NZ,DRWBNR	; Ja
;----------------------------------------------
				;Test, ob dieser Puffer da ist
	PUSH	AF		;merken Puffernummer
	LD	HL,DBNB
	CP	(HL)		;richtige Puffernummer?
	JR	NZ,DBN		; Nein
;	------------------------
	LD	HL,DBTRK
	LD	A,(DUTRK)	;geforderte Spur
	CP	(HL)		; richtige Spur?
	JR	NZ,DBN
;	------------------------
	LD	A,(DBDEV)	;zum Puffer gehoeriges Geraet
	CP	C		; richtiges Geraet?
	JR	Z,DBMAT		;ja, Sektor steht im Puffer
;==============================================
DBN:	PUSH	BC		;retten ddrive
	CALL	DBTRW		;veraenderten Puffer ausgeben			## 1 ##
	POP	BC		;c:=ddrive
;	
	LD	HL,DBDEV
	LD	(HL),C
;
	LD	A,(DUTRK)
	LD	(DBTRK),A
;
	CALL	DGETPB		;ix:=dpb(c)
	LD	B,(IX+DPBSLC)
	LD	HL,DBSLC
	LD	(HL),B
;
	LD	A,(IX+DPBBFM)	;Zahl der 128er Sektoren -1
	INC	A
	ADD	A,A		;CY:=0
	INC	B		;fuer djnz, falls dpbslc=0
DBSNBZ:	RRCA			;Zahl der phys. Sekt. im Puff.
	DJNZ	DBSNBZ
	LD	D,A		;merken
;
	XOR	A
	POP	BC		;b:=geforderte Puffernr.
	PUSH	BC
	LD	HL,DBNB
	LD	(HL),B
	INC	B
	DEC	B		;Puffernr. 0?
	JR	Z,DBSEC0	;ja
DBSECZ:	ADD	A,D		;0. phys. Sekt. im Puffer
	DJNZ	DBSECZ		;=dbsnb.*Puffernr.
DBSEC0:	LD	E,A		;merken Pufferanf.-Sektor
;
	LD	B,(IX+DPBSLC)
	LD	A,(IX+DPBSPT)
	INC	B		;wegen djnz
	ADD	A,A
DBSECM:	SRL	A		;phys. Sektoranzahl
	DJNZ	DBSECM
	SUB	E		;Restsektorzahl auf Spur
	CP	D		;>= Zahl zu transferierender?
	JR	NC,DBSECO	;ja
	LD	D,A		;sonst nur Restsektorzahl
DBSECO:	INC	E		;Sektoren zaehlen ab 1
	LD	A,E
	LD	(DBSEC),A	;hinterlegen Sektor, Sektorzahl
	LD	A,D
	LD	(DBSNB),A
;
	LD	HL,DBFLG
	RES	DBFWR,(HL)
	ENDC
	COND	(DBUFSZ.GT.7).AND.ENWRIT
	BIT	DBF00,(HL)	;muss neuer Puffer gel. werden?
	JR	NZ,DBPRR	;ja
;
; nur dann kein preread, wenn Rest BDOS-Block >= phys. Puff.
; und Rest BDOS-Block auf Pufferanfang beginnt
	LD	A,(UNACNT)
	CP	(IX+DPBBFM)	;Restzahl-1 >= Puffergr.-1 ?
	JR	C,DBPRR		; nein:preread
;
	LD	A,(DUSEC)	;Sektornr.
	DEC	A		; ab 0 zaehlen
	AND	(IX+DPBBFM)	;rel. Sekt.nr. des
				; BDOS-Blocks zum Pufferanfang
	JR	NZ,DBPRR
;
	LD	(DBERRF),A	;fehlerfrei gel. anzeigen
;
DBPRR:	CALL	NZ,DBTRAN	;Puffer lesen					## 2 ##
	ENDC
;----------------------------------------------
	COND	(DBUFSZ.GT.7).AND.(.NOT.(ENWRIT.EQ.1))
	CALL	DBTRAN								## 2" ##
	ENDC
;==============================================
; Sektor in/aus Puffer holen
;
	COND	DBUFSZ.GT.7
DBMAT:	
	POP	AF		;Puffernr. in Spur wegschm.
	POP	AF		;128-er Index im Puffer
	PUSH	AF
	RRA
	LD	B,A
	LD	C,0
	RR	C		;BC=Sektornr*128
	LD	HL,DBUF
	ADD	HL,BC		;Quelle=Adresse im Puffer
	LD	DE,(DUDMA)	;Ziel=Nutzer-DMA
	LD	A,(DUFLG)
	BIT	DUFWR,A		;Schreiben?
	JR	Z,DSMOVE	; nein
;	---------------------------------------
	LD	A,(DBFLG)
	SET	DBFWR,A		;anzeigen Puffer beschrieben
	LD	(DBFLG),A
	EX	DE,HL		;Quelle, Ziel vertauschen
;	---------------------------------------
DSMOVE:	LD	BC,128
	CALL	FLLDIR
	POP	AF		;128-Index im Puffer
	CP	(IX+DPBBFM)	;letzter Sektor im Puffer?
	JR	Z,DMOVEW	; ja:Puffer ausgeben
;	---------------------------------------
	LD	A,(DWRTYP)
	CP	1		;write to directory?
DMOVEW:	CALL	Z,DBTRW		; ja:veraend. Puffer ausgeben			## 3 ##
	LD	A,(DBERRF)	;Ergebnis letztes dbtran
	RET
;**********************************************
;
; Schreiben Puffer, wenn notw.
;==============================================
DBTRW:	LD	HL,DBFLG
	BIT	DBFWR,(HL)	;Puffer veraendert?
	RET	Z		;nein, Schreiben unterdruecken
	ENDC
;**********************************************
;
; gemeinsamer Zweig Lesen/Schreiben Puffer
;==============================================
	COND	AUTFER.OR.(DBUFSZ.GT.7)
DBTRAN:	LD	HL,DBCDB
	ENDC
	COND	DBUFSZ.GT.7
	CALL	DSKTRA
	LD	(DBERRF),A	;Fehlerflag stellen
	LD	HL,DBFLG
	RES	DBFWR,(HL)	;Puffer ist nicht veraendert
	RET
	ENDC
;----------------------------------------------
	COND	AUTFER.AND.(.NOT.(DBUFSZ.GT.7))
	JR	DSKTRA
	ENDC
;**********************************************
;
; Lesen beliebigen Sektor-Id.
;==============================================
DSIDTT:	COND	AUTFER
	LD	(DFRTRK),A	;Spur in A
;----------------------------------------------
DSIDTR:	LD	HL,DFRCDB	;Spur in (DFRTRK)
	JR	DSKTRA		;belieb. SektId lesen
	ENDC
;**********************************************
;
; gemeinsamer Zweig Read/Write 128-Sektor einzeln
;----------------------------------------------
DRWSEC:	LD	HL,DUFLG
;==============================================
;
; interner Aufruf phys. Diskettentransfer
; i HL auf CDB
;----------------------------------------------
DSKTRA:
;==============================================
;
; Umkleidung des physischen Disketten-Transfers
;----------------------------------------------
;
; Parameter: HL auf CDB mit folgender Struktur:
;
; +0: cdbfl	;Flags	(Struktur angepasst an ftkom)
;DIOF00	EQU	0	;** frei ** (frueher Verify nach Schreiben) ?s. Puffer-CDB ?
;DIOFID	EQU	1	;fest	;=1, wenn nur Sektid. zu lesen
;DIOFWR	EQU	2	;fest	;=1, wenn Schreiben
;DIOFFM	EQU	3	;fest	;=1, wenn temporaer FM-Format erzwungen
;DIOFTR	EQU	4		;=1, wenn keine Fehlermeldung (und -behandlg)
;DIOFHD	EQU	5		;=1, wenn Kopf hochnehmen ("headup")
;DIOFPS	EQU	6		;=1, wenn trk,sid,sec schon physisch
;DIOFS1	EQU	7	;fest	;=1, wenn Rueckseite (Aend CP/A !)
;
; ab hier unwichtig bei "diofhd" in cdbfl =1 (headup)
; +1: cdbdev	;logisches Geraet 0 .. dphnb-1
; +2: cdbtrk	;log./phys. Spur
; +3: cdbsid	;bel./phys. Seite
; +4: cdbsec	;log./phys. Sektor
; +5: cdbslc	;Sektorlaengencode (0=128, 1=256, 2=512, 3=1024)
; +6: cdbsnb	;Anz. zu uebertr. ph. Sekt. (wenn =0, so nur position.)
; +7,8: cdbdma	;Transferadresse
;
; Return, falls nicht "diofhd" in cdbfl =1:
;	A=0 (ret z) bei fehlerfrei, sonst A=1 (ret nz) bei cdbfl, "dioftr" =0
;	  oder Returncode phys. Transfer
;	E:=trk, D:=sid ,L:=sec, H:=len
;	BC,IX unveraendert
;==============================================
;
;Aufruf ueber Sprungvektor von BIOS-Erweiterung
;----------------------------------------------
LDISKI:	PUSH	BC		; (1) (Marke war DISKIO)
	PUSH	IX		; (2)
;
	LD	DE,DIOCDB	;CDB des Nutzers auf internen Hilfsspeicher
	LD	BC,DIOCDL	;da modifiziert
 	PUSH	DE		; (3)
	CALL	FLLDIR		;falls Original im ROM-Adressbereich (Aend CP/A !)
	POP	HL		; (3) HL auf DIOCDB
	BIT	DIOFHD,(HL)	;Kopf hochnehmen?
	LD	A,'Z'
	JP	NZ,DIOERT	; ja:Fehler
;	---------------------------------------
 	INC	HL
	LD	C,(HL)		;logisches Laufwerk
	CALL	DGETPB		; -------------------->	IX = DPBx
	LD	A,'D'
	JP	Z,DIOERT	;LW ex. nicht-->
;----------------------------------------------
;%%% Abbildung mehrerer log. LW auf phys. LW 0
	LD	A,(IX+DPBDNR)
	AND	A		;Phys. LW 0 ?
	JR	NZ,LPLW1	; Nein-->
;	---------------------------------------
	LD	A,(LPTAB)	;Vorher gleiches log. LW?
	CP	C
	JR	Z,LPLW1		; ja-->
;	---------------------------------------
	LD	A,C
	LD	(LPTAB),A	;log. LW merken
	ADD	A,'A'
	LD	(LPCHLG),A	;log. LW 'A'...
	LD	HL,LPCHNG	;Aufforderung zum Disketten-Wechsel
	CALL	XLPLW		;Anzeige, Tastenbetaetigung
;-----------------------------------------------
LPLW1	LD	HL,DIOCDB
	BIT	DIOFPS,(HL)	;trk,sid,sec schon physisch? (Aend CP/A !)
	JR	NZ,DIOPHY	; Ja --> DIOPHY
;==============================================
; Track, Side und Sector entpsr. Diskettenformat setzen
	INC	HL
	INC	HL
	LD	D,(HL)		;Track merken in D
	LD	E,D		; und E
	INC	HL
	INC	HL
	LD	C,(HL)
	DEC	C		;Sektornr. ab 0 in C
;	---------------------------------------
 	BIT	DPBF86,(IX+DPBFLG) ;Fortsetzung Disk auf Ruecks.?
	JR	NZ,DIOTS2	   ; ja-->
;	------------------------
	BIT	DPBFDS,(IX+DPBFLG) ;ungerade Spuren auf Rueckseite?
	JR	Z,DIOTRS	   ; nein: einseitig
;	------------------------
	SRL	D		;Spur halbieren
	JR	NC,DIOTRS	; -->Vorderseite (gerade Spur)
	JR	DIOTS1		; -->Rueckseite
;	---------------------------------------
DIOTS2:	LD	B,(IX+DPBTRK)	;log. Spurzahl
	SRL	B		;Spuren auf Vorderseite
	LD	A,D
	SUB	B		;Spur auf Vorderseite?
	JR	C,DIOTRS	; ja: Spur in d unveraendert lassen
;	---------------------------------------
				; nein: 40->0; 41->1; ...; 79->39
	BIT	DPBFSV,(IX+DPBFLG) ;Ruecks. von aussen nach innen?
	JR	NZ,DIOTS4	   ; ja-->
	CPL			   ; nein: 40->-1; 41->-2; ...; 79->-40
	ADD	A,B		   ;       40->39; 41->38; ...; 79->0
DIOTS4:	LD	D,A
;	---------------------------------------
DIOTS1:	LD	A,(DIOFLG)
	SET	DIOFS1,A	;vermerken Rueckseite
	LD	(DIOFLG),A
	LD	A,(IX+DPBSN0)	;Versch. der Sektornr. auf Rueckseite
	ADD	A,C		;Sektornr. evtl. weiterzaehlen
	CP	C		;Weiternummerierung auf Rueckseite?
	LD	C,A
	JR	NZ,DIOTRS	; ja: side=0 (!! KAYPRO)
;	---------------------------------------
	LD	A,1		;side:=1
	JR	DIOTSS
;	---------------------------------------
DIOTRS:	XOR	A		;side:=0
DIOTSS:	LD	(DIOSID),A	;phys. Seite setzen
	LD	A,D
	LD	(DIOTRK),A	;phys. Spur setzen
;----------------------------------------------
	LD	A,E		;log. Spurnr. zurueck nach A
	PUSH	IX		; (3)
	POP	HL		; (3)
	LD	DE,DPBSTR	;D = 0
	ADD	HL,DE
	CP	(IX+DPBOFS)	;Systemspur?
	JR	C,DIOSSP	;ja, Sektornummern nicht logisch
;	---------------------------------------
	LD	E,C
	ADD	HL,DE		;HL entspr. Index in dpbstr
	LD	C,D		;c:=0
DIOSSP:	LD	A,C		;phys. Sektornr. ab 0
	ADD	A,(HL)		;+echte Sektornr.
	LD	(DIOSEC),A	;phys. Sektor setzen
;==============================================
DIOPHY
; i ret, BC, IX im Stack
; i cdb auf diocdb
; i IX auf DPB
				;interne Wiederholung LDISKI
DIORTY	PUSH	IX		; (3)
;----------------------------------------------
; Zusammenbau des Steuerblocks fuer phys. Floppy-Routine
	LD	HL,DIOCDB
	LD	A,71H
	BIT	DIOFID,(HL)	;Lesen Sektid?
	JR	NZ,DIO00	; ja-->
	LD	A,70H
	BIT	DIOFWR,(HL)	;kein Schreiben?
	JR	Z,DIO00		; ja-->
	LD	A,50H		;Schreiben
DIO00:	LD	(FLKDO),A	;setzen Befehl
;
	LD	A,(IX+DPBDNR)	;physische LW-Nr.
	LD	(FLDEV),A
;
	LD	A,(DIOTRK)	;Spur
	LD	(FLTRK),A
;
	LD	A,(DIOSID)	;Seite
	LD	(FLSID),A
;
	LD	A,(DIOSEC)	;Sektor
	LD	(FLSEC),A
;
	LD	A,(DIOSLC)	;Sektorlaengencode
	LD	(FLSLC),A
;				 FLGAP: GAP3
	LD	A,(DIOSNB)	;Sektoranzahl
	LD	(FLSNB),A
;				 FL08: MFM (nicht aenderbar!)
	LD	A,(IX+DPBSTP)	;Anzahl der Stepimpulse
	LD	(FL09),A
;
	LD	HL,(DIODMA)	;Transferadresse
	LD	(FLDMA),HL
;
	LD	BC,DPBDRT	;Drive Param Block
	ADD	IX,BC
	LD	(FL12),IX
;----------------------------------------------
	CALL	XISMON		;BIOS-Monitor verbieten
	LD	IX,FLKDO
	CALL	BIFM00		;$$$ phys. Transfer $$$
	LD	A,(FL14)
	CALL	XNAMON		;BIOS-Monitor wieder erlauben
;----------------------------------------------
	POP	IX		; (3) IX wieder auf DPBx
;----------------------------------------------
DIOERT	LD	HL,DIOCDB
	BIT	DIOFTR,(HL)	;Fehlerprotokoll und -behandlung  unterdr.?
	JR	NZ,DTROK	; ja
	OR	A		;Returncode
	JR	Z,DTROK		; -> fehlerfrei
;==============================================
	COND	ERRVAR
	LD	DE,DERRRW	;Operation
	LD	BC,5
	BIT	DIOFWR,(HL)
	JR	NZ,DERRR1
	LD	HL,RDZK         ; (Lesen)
	JR	DERRR2
DERRR1	LD	HL,WRZK	 	; (Schreiben)
DERRR2	LDIR
;
	LD	HL,FL14		;Fehlercode
	LD	DE,DERRCD
	CALL	MBRECO		; (zweistellig)
;
	LD	A,(DIODEV)	;LW
	ADD	A,'A'
	LD	(DERRLW),A
;
	LD	HL,FLTRK	;Spur
	LD	DE,DERRTR
	CALL	MBRECO		; (zweistellig)
;
	LD	A,(FLSID)	;Seite
	LD	DE,DERRSI
	CALL	MRECOR		; (einstellig!)
;
	LD	HL,FLSEC	;Sektor
	LD	DE,DERRSC
	CALL	MBRECO		; (zweistellig)
;
	LD	HL,DERRMS
	CALL	XDER1
	ENDC
 	LD	A,1		;return mit Fehler
;----------------------------------------------
DTROK:	OR	A		;stellen Z-Flag
	LD	DE,(FLTRK)	;E:=trk, D:=sid
	LD	HL,(FLSEC)	;L:=sec, H:=len
	POP	IX		; (2)
	POP	BC		; (1)
	RET
;----------------------------------------------
RDZK	DEFM	'Read '
WRZK	DEFM	'Write'
;**********************************************
; Stellen HL entsprechend Sektorlaengencode in (A)
;
;=================================================
; ret nz bei unzulaessigem
;
DTRSLA:	COND	AUTFER
	OR	A
	LD	HL,DTRSL0
	RET	Z		;=0 (128)
	DEC	A
	LD	HL,DTRSL1	;=1 (256)
	RET	Z
	DEC	A
	LD	HL,DTRSL2	;=2 (512)
	RET	Z
	DEC	A
	LD	HL,DTRSL3	;=3 (1024)
	RET
	ENDC
;**********************************************
;
; allgemeine Unterprogramme
;==============================================
; Ermitteln DPH und DPB von (c) nach HL bzw. IX
; ret z		DPH existiert nicht, HL=0
; ret nz	ok, HL auf DPH, IX auf DPB
; BC, DE bleibt erhalten
;
DGETPB:	PUSH	DE
	LD	HL,0
	LD	A,C
	CP	16		;DPH definiert?
	JR	NC,DGETP0	;nein
;	---------------------------------------
	EX	DE,HL
	LD	HL,DPHATB	;Adresstabelle fuer DPH's
	LD	E,C
	ADD	HL,DE
	ADD	HL,DE
	LD	A,(HL)
	INC	HL
	LD	H,(HL)
	LD	L,A		;hl:=^DPH
	PUSH	HL
	LD	E,10
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)		;de:=^dpb
	PUSH	DE
	POP	IX		;ix:=^dpb
	POP	HL
;	---------------------------------------
DGETP0:	POP	DE
	LD	A,H
	OR	L		;ret z bei hl=0
	RET
;************************************************
;
; Modifizierungstabellen entspr. Sektorlaenge und LW-Typ
; (Struktur)
;------------------------------------------------
;	COND	format
DSLTRK	EQU	0		;benutzte Spuren
DSLSPT	EQU	DSLTRK+1	;Sektoren/Spur
DSLDIR	EQU	DSLSPT+1	;Dir-Eintraege
DSLOFF	EQU	DSLDIR+1	;2*offset
				;[+Flag fuer festes offset]
DSLFO	EQU	1		;festes offset
DSLVO	EQU	0		;offset =0, falls Directory mgl.
DSLBLK	EQU	DSLOFF+1	;rel. Adr. Tab. BDOS-Blockgroesse
DSLL	EQU	5		;Laenge eines Eintrags
;----------------------------------------------
; Zur automatischen Bestimmung des Spurformats wird dasjenige
; Format der Spur "dlgint" benutzt, alle folgenden Spuren
; muessen das gleiche Format haben!
DLGINT	EQU	3	;groesste Anzahl SS-Systemspuren
;----------------------------------------------
; Reihenfolge
; 5", 40 Tr, SS	 LW 1.2
; 5", 80 Tr, SS	 LW 1.4
; 5", 40 Tr, DS	 ?
; 5", 80 Tr, DS	 LW 1.6
;----------------------------------------------
; 128
DTRSL0:	DFB	40,26,63,2*2+DSLVO,DBL1K-$	;CP/M Standard
	DFB	80,26,127,2*2+DSLVO,DBL2K-$
	DFB	80,26,127,2*0+DSLFO,DBL2K-$
	DFB	160,26,127,2*0+DSLFO,DBL2K0-$
;----------------------------------------------
; 256
DTRSL1:	DFB	40,32,63,2*3+DSLFO,DBL2K-$	;SCP Hausformat A51xx
	DFB	80,32,63,2*3+DSLFO,DBL2K-$	;SCP
	DFB	80,32,127,2*4+DSLFO,DBL2K-$
	DFB	160,32,127,2*4+DSLFO,DBL2K0-$	;SCP Hausformat PC1715
;----------------------------------------------
; 512
DTRSL2:	DFB	40,36,63,2*0+DSLFO,DBL1K-$
	DFB	80,36,127,2*0+DSLFO,DBL2K-$
	DFB	80,36,127,2*0+DSLFO,DBL2K-$
	DFB	160,36,127,2*0+DSLFO,DBL2K0-$
;----------------------------------------------	
; 1024
DTRSL3:	DFB	40,40,63,2*2+DSLVO,DBL1K-$	;CP/A Standard A51xx
	DFB	80,40,127,2*2+DSLVO,DBL2K-$	;CP/A
	DFB	80,40,127,2*0+DSLVO,DBL2K-$	;CP/A
	DFB	160,40,191,2*4+DSLVO,DBL2K0-$	;CP/A (und SCP)
;----------------------------------------------
; Modifizierungstabellen fuer BDOS-Blockgroesse
DBL1K:	DFB	3,7,0		;Bl. Shift, Bl. Mask, Ext. Mask
DBL2K:	DFB	4,0FH,1
DBL2K0:	DFB	4,0FH,0		;fuer Kapazitaet >255
;==============================================
; CP/M-LOG.-SEKTORTRANSLATE-TABELLE (fuer 26*128)
;
XLT:	DFB	1,7,13,19,25,5
	DFB	11,17,23,3,9,15
	DFB	21,2,8,14,20,26
	DFB	6,12,18,24,4,10
	DFB	16,22
	ENDC
;***********************************************
;Ausgabe mit Warten
;
BIOSMS	CALL	BIOSM0	;Ausgabe
BV24W1	PUSH	BC
	LD	B,25	;ca. 2.5s warten
BIO100	PUSH	HL
	LD	HL,12000
BIO200	DEC	HL
	LD	A,H
	OR	L
	JR	NZ,BIO200
	POP	HL
	DJNZ	BIO100
	POP	BC
	JR	BIOSI7	;Zeilenschaltung
;================================================
; Ausgabe mit Eingabe
;
BIOSME	CALL	BIOSM0
;================================================
; Eingabe Zeichen und Zeilenschaltung
;
BIOSIN	CALL	LORIPU	;Loe Ringpu
BIOSI5	CALL	RDRIPU	;Lesen Ringpu (kein BIOS-Ruf!)
	CP	'*'
	JR	NZ,BIOSI5 ;Warten auf '*'
;
BIOSI7	LD	A,0DH
	CALL	OUTASC	;Zeilenschaltung (kein BIOS-Ruf!)
	LD	A,0AH
	JP	OUTASC	; (kein BIOS-Ruf!)
;==============================================
; Ausgabe Text ab (HL) bis 00h
;
BIOSM0:	PUSH	HL
	CALL	KOMSCR	;Kommando-SCREEN
	POP	HL
BIO10	LD	A,(HL)
	OR	A
	RET	Z	;Ende-->RET
	PUSH	HL
	CALL	OUTASC	;Ausgabe (kein BIOS-Ruf!)
	POP	HL
	INC	HL
	JR	BIO10
;**********************************************
;PATCH-Ruf fuer BIOS-Error u WH bei Not Ready
;----------------------------------------------
BDER1	JP	BIOSMS
;
;**********************************************
; Rueckkonvertieren Byte ab (HL) nach (DE)
; RET: 2 Zeichen ab (DE), DE zeigt auf naechstes freies Byte
;
MBRECO:	LD	A,(HL)
;==============================================
; Rueckkonvertieren Byte in A nach (DE)
; RET: 2 Zeichen ab (DE), DE zeigt auf naechstes freies Byte
;
MRECOA:	CALL	MRECA
;==============================================
; Rueckkonvertieren A in HEX-Ziffern nach (DE)
; RET: A um 4 bits nach rechts rotiert
;      DE zeigt auf naechstes Byte
;
MRECA:
MRECOL:	RRCA	;linkes Halbbyte
	RRCA
	RRCA
	RRCA
MRECOR:				;rechtes Halbbyte
	PUSH	AF		;fuer 2. mreca-Aufruf retten
	AND	0FH
	SUB	9+1
	JR	C,MRECOD	;0..9
	ADD	A,7		;A..F
MRECOD:	ADD	A,'0'+10
	LD	(DE),A
	INC	DE
	POP	AF
	RET
;**********************************************
;
; ???? Koepfe abheben und Motoren aus ????
;==============================================
;HEADUP:
;**********************************************
;
;Floppy-RAM initialisieren fuer RBASIC
;==============================================
BFLINI	CALL	XBFLIN		;Test weiterer LW
;	-------------------
	LD	HL,SRANF	;Gesamt-RAM u.
	LD	DE,LFRAMA 	; LW A
	LD	BC,SRLAE
	LDIR
;
	LD	HL,SDPHA	;LW B im LW 0
	LD	DE,DPHB
	LD	BC,SDPHL
	LDIR
	LD	HL,DPBB
	LD	(DPHB+10),HL
	LD	HL,CHKB
	LD	(DPHB+12),HL
	LD	HL,ALVB
	LD	(DPHB+14),HL
;	-------------------
	LD	HL,BXDER1+2
	LD	DE,XDER1+2
	LD	BC,BXDER1+3-BXSELE	;PATCH-Rufe init
	LDDR
;	-------------------
	LD	IX,FLKDO	;Init phys. Treiber
	CALL	BIFM00
;	-------------------
	LD	(IX+0),90H	;Test auf phys. LW 1
	LD	(IX+1),1
	CALL	BIFM00
	LD	A,(RSTAT)
	AND	30H		;Bereit o. Spur 0 ?
	JR	Z,BFLI10	; Nein-->
;
	LD	A,1
	LD	(DPBB+DPBDNR),A ;LW B im LW 1
;	-------------------
BFLI10	LD	(IX+1),2	;Test auf phys. LW 2
	CALL	BIFM00
	LD	A,(RSTAT)
	AND	30H		;Bereit o. Spur 0 ?
	JR	Z,BFLI20	; Nein-->
;
	LD	HL,DPHC
	LD	(DPHATB+4),HL	;LW C im LW 2
	LD	HL,SDPHA
	LD	DE,DPHC
	LD	BC,SDPHL
	LDIR
	LD	HL,DPBC
	LD	(DPHC+10),HL
	LD	HL,CHKC
	LD	(DPHC+12),HL
	LD	HL,ALVC
	LD	(DPHC+14),HL
	LD	A,2
	LD	(DPBC+DPBDNR),A
;	-------------------
BFLI20	RET
;----------------------------------------------
;Patch-Rufe
;
BXSELE	JP	BIOSM0	;Anzeige Disk-Format
BXLPLW	JP	BIOSME	;Diskwechsel im DSE-LW
BXDER1	JP	BDER1	;BIOS-Error u WH bei Not Ready
;**********************************************
;
;Standardwerte fuer RAM des logischen Floppy-Treibers
;
SRANF:
;==============================================
;Standard-Floppy-LDIR
;
;----------------------------------------------
SFLLDI	PUSH	AF
	IN	A,(PPIA)
	PUSH	AF		;Istbank retten
SFLLD1	LD	A,0AAH		;alles Bank 2
	OUT	(PPIA),A
;
	LD	A,B
	OR	C
	JR	Z,SFLLD2
	LDIR			;umspeichern
;
SFLLD2	POP	AF
	OUT	(PPIA),A	;Bank zurueck
	POP	AF
	RET
;==============================================
; Standard-Fehlermeldung Disk I/O Error
;
;----------------------------------------------
SDERRM:	COND	ERRVAR
	DFB	0DH,0AH
	DEFM	'BIOS-Err XX: Write LW=X T=XX Si=X Se=XX'
	DFB	07H,0
	ENDC
;==============================================
; Standard-CDB fuer Bestimmung Spurformat
;
;----------------------------------------------
SDFRCD:	COND	AUTFER
	DEFB	(1.SHL.DIOFID)+(1.SHL.DIOFTR)
;		Lesen Sektorid., kein Fehlerprotokoll
	DEFB	0FFH		;Geraet
	DEFB	0FFH		;Spur
	DEFB	0FFH		;Seite (bel.)
	DEFB	1		;Sektor (bel.)
	DEFB	0		;Sektorlaengencode (bel.)
	DEFB	1		;Sektoranzahl (>0)
	DEFW	FLTRK		;dorthin Sektorid hinterlegt
	ENDC
;==============================================
; Standard-Puffer-CDB
;
;----------------------------------------------
SDBCDB:	COND	AUTFER.OR.(DBUFSZ.GT.7)
	DEFB	0
	DEFB	0FFH
	DEFB	0FFH
	DEFB	0FFH
	DEFB	0FFH
	DEFB	0FFH
	DEFB	0FFH
	ENDC
	COND DBUFSZ.GT.7
	DEFW	DBUF
	ENDC
	COND AUTFER.AND.(.NOT.(DBUFSZ.GT.7))
	DEFW	DIRBUF
	ENDC
;==============================================
; Standard-CDB fuer ungepufferte E/A
;
;----------------------------------------------
SDUCDB:	DEFB	0
	DEFB	0
	DEFB	0FFH
	DEFB	0FFH		;Seite
	DEFB	0FFH
	DEFB	0		;128 Bytes Sektorlaenge
	DEFB	1		;immer nur 1 Sektor
	DEFW	0FFFFH
;==============================================
; Standard-Pufferzugriff
;
;----------------------------------------------
	COND	ENWRIT.AND.(DBUFSZ.GT.7)
SUNACN:	DFB	0,0FFH,0FFH,0
	ENDC
	COND	DBUFSZ.GT.7
	DEFB	0FFH
	DEFB	0FFH
	DEFB	0	;Ergebnisflag letztes dbtran
	ENDC
;==============================================
;%%% Standard-Abbildung mehrerer log. LW auf 1 phys. LW
;
;----------------------------------------------
SLPTAB:	DEFB	0		;log. LW A fuer phys. LW 0
	DFB	0DH,0AH
	DEFM	'Disk. '
	DEFM	'X in DSE stecken; dann Taste "*"'
	DFB	07H,0
;==============================================
;Standard-Anzeige Diskettenkapazitaet
;
;----------------------------------------------
SDISKA	DFB	0DH,0AH
	DEFM	'LW X=XXXK'
	DFB	0DH,0AH,0
;==============================================
;Standard-Paramterfeld fuer phys. floppy-Routine
;
;----------------------------------------------
SSFLP:	DEFB	80H	;Kommando
	DEFB	0	;Laufwerk
	DEFB	0	;Spur
	DEFB	0	;Seite
	DEFB	1	;Sektor
	DEFB	0	;Sektorlaengencode
	DEFB	0EH	;gap 3
	DEFB	1	;Sektorzahl
	DEFB	1	;0/1  FM/MFM (BIC: nur MFM!)
	DEFB	1	;Schritte von Spur zu Spur
	DEFW	0	;Transferadresse
	DEFW	0	;Adresse Drive Param Block
	DEFB	0	;Ergebnis-Status
;==============================================
; Standard-Tabelle der DPH-Adressen
;
;----------------------------------------------
SDPHAT:	DEFW	DPHA	;A
	DEFW	DPHB	;B
	DEFW	0	;C
	DEFW	0	;D
	DEFW	0	;E
	DEFW	0	;F
	DEFW	0	;G
	DEFW	0	;H
	DEFW	0	;I
	DEFW	0	;J
	DEFW	0	;K
	DEFW	0	;L
	DEFW	0	;M
	DEFW	0	;N
	DEFW	0	;O
	DEFW	0	;P
;==============================================
; Standard-Disk-Parameter-Block (fuer alle phys. Laufwerke)
;
;----------------------------------------------
;DISK-PARAMETER-HEADER
;
SDPHA:	DEFW	0		;kein log. Sektortranslate
	DEFW	0		;BDOS Spur
	DEFW	0		;BDOS Sektor
	DEFW	0		;BDOS Dir
	DEFW	DIRBUF
 	DEFW	DPBA
	DEFW	CHKA
	DEFW	ALVA
;
;CP/M-STANDARD-DISK-PARAMETER-BLOCK
; fuer BIC Standard: 5*1024*160, 4 Systemspuren
;
SDPBA:	DEFW	40		;Sekt/Spur
	DEFB	4		;Blockshift (2k)
	DEFB	15		;Blockmaske
	DEFB	0		;Extentmaske
	DEFW	780/2-1	 	;Blockzahl (ohne System)
	DEFW	128-1		;Dir Entries
	DFB	0C0H,0		;Dir Allocation
	DEFW	128/4		;Checksize
	DEFW	4		;Systemspuren
;
;DISKETTEN-PARAMETER (NICHT-STANDARD-DBP)
;
	DEFB	00100000B	;Disk,aut.Formaterk,DS(Ruecks=ung.Spuren),
				; kein FM,keine 128er Spuren
	DEFB	3		;1k Sektorlaenge
	DEFB	8-1		;Puffermaske:8 128er Sektoren im Puffer
	DEFB	1		;1 Stepimpuls von Spur zu Spur
	DEFB	0		;kein Weiternummerieren d. Sekt auf Rueckseite
	DEFB	160		;160 log. Spuren
;
;PHYS. LAUFWERKSNUMMER
;
	DEFB	0		;phys. LW-Nr.
;
;LAUFWERKS-PARAMETER (SCP1715-DRIVE-PARAMETER-BLOCK)
; fuer MFS 1.6
;
	DEFB	00111001B	;Max.26 Sekt/Spur,80 Spur,5",MFM,DS
	DEFB	80		; 1. Spur mit Praekompensation
	DEFB	4		;Schrittzeit SRT in ms
	DEFB	4		;Kopfberuhigungszeit nach Andruck HLT in ms
	DEFB	10		;Kopfberuhigungszeit nach Step in ms
	DEFB	80		;1. Spur mit Schreibbegrenzung (bei BIC ign.)
	DEFB	0		;Optionen: mit Verify nach Schreiben
	DEFB	32		;Kopfentladezeit HUT in ms
	DEFB	0		;Praekompzeit (bei BIC ignoriert)
	DEFB	0		;frei
	DEFB	80		;LW hat 80 phys. Spuren
;
;PHYSISCHE SEKTOR-TRANSLATE-TABELLE
;
	DFB	1,2,3,4,5,6	;Reihenfolge fuer Sektorzugriff
	DFB	7,8,9,10,11,12	; (ausser fuer 26*128)
	DFB	13,14,15,16,17,18
	DFB	19,20,21,22,23,24
	DFB	25,26
;----------------------------------------------
SDPHL	EQU	$-SDPHA
;==============================================
SRLAE	EQU	$-SRANF
;***********************************************
