;########################################################################
;#  Physischer Floppy-Modul  FD1.S ( 3,75 MHz-Version )			#
;#  VERSION:  1. Sektor-Lesen OHNE ID-Feld-Lesen			#
;#	      2. Sektor-Schreiben OHNE ID-Feld-Lesen			#
;#	         D.h.Annahme,dass b.Posit.i.a.die Sollspur erreicht w.	#
;#	         Im F.-fall w.ueb.HOME neu posit.b.lesz=0 bzw im Fall	#
;#	         log.ISTsp.in PCN = SOLLsp.in (ix+2),tats.Kopfpos.aber	#
;#	         falsch,w.ueber homez1 neuposit.u.RD/WR-Ruf wiederholt	#
;#	         Austritt mit F.= <ST0> = F.-Klasse 40h/80h/C0h		#
;#									#
;#	In IX w. Anfangsadr.eines 15 Byte langen Param.-feldes ueberg.	#
;#	IX wird durch den Modul nicht zerstoert. Der Akku enthaelt den	#
;#	Status der abgeschlossenen Operation. (A=00 : kein Fehler)	#
;########################################################################
;file:	FD1.S,FDUP1.S,FDDAT1.S
;date:	28.09.88/LU
;
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Aufbau der echten Schnittstelle zw.Blockungs/FD-Modul fuer:
;		  ;Lesen / Schreiben				I Formatieren
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;FL00:	  db 70h  ;BYTE  0 :	BEFEHL (Lesen)	 	(ix)   	I
;	  db  00  ;BYTE  1 :	LAUFWERK		(ix+1)	I
;	  db 20h  ;BYTE  2 :	SPUR			(ix+2)	I
;	  db  00  ;BYTE  3 :	KOPF			(ix+3)	I
;	  db  01  ;BYTE  4 :	SEKTOR			(ix+4)  I  Sektorinhalt
;	  db  03  ;BYTE  5 :	rel.DATENFELDLAENGE     (ix+5)	I
;		  		n=0..3/128,256,512,1024 B/Sek.  I	
;	  db  0Eh ;BYTE  6 :	LUECKE (GAP 3)   	(ix+6)  I  Luecke 3
;	  db  01  ;BYTE  7 :	SEKTORANZAHL(1..5/1024)	(ix+7)	I
;	  db  01  ;BYTE  8 :	VERFAHREN (0/1=FM/MFM)	(ix+8)	I
;	  db  01  ;BYTE  9 :	SCHRITTE/SPUR:1/2=80/40	(ix+9)	I
;	  dw PUFF ;BYTE 10 :	PUFFERADRESSE (LOW)	(ix+10)	I
;		  ;BYTE 11 :	PUFFERADRESSE (HIGH)	(ix+11)	I
;	  dw DRPBA ;BYTE 12 :	DRIVEPARAM.-BLOCK (LOW)	(ix+12) I
;		  ;BYTE 13 :	DRIVEPARAM.-BLOCK (HIGH)(ix+13) I
;	  db  00  ;BYTE 14 :	STATUS			(ix+14) I
;
;DRIVE-PARAMETER-BLOCK:
;(Zeitangaben in ms)
;----------------------
;DRPBA:
;	db  05		;BYTE 0: 	Laufwerktyp		
;	db  80		;BYTE 1: 	1.Spur mit Praekomp.,d.h. keine
;	db  14  	;BYTE 2:	Schritt-bzw.Spurwechselzeit = 4 ms b.4MHz-FDC
;	db  02h		;BYTE 3: 	Kopfberuhigungszeit nach Andruck
;			;		(vertik.Schwingen = 2 ms; 0 entspr.512ms !!!)
;	db  10		;BYTE 4: 	Kopfber.zeit nach Step =10ms z.Elim.
;					horiz.Schwingen d.Softtimer UP Time1
;	db  80		;BYTE 5: 	1.Spur mit Schreibbegrenzung (keine)
;	db  00		;BYTE 6: 	;Option		
;	    		;bit0:frei
;			;bit1:frei
;			;bit2:frei
;			;bit3:1= Arbeit ohne Kon-
;			;	 trollesen nach Schreiben
;			;bit4-7: frei
;	db  00		;BYTE 7: frei
;	db  00		;BYTE 8: Praecompensationszeit
;			; 0 = 125ns
;			; 1 = 250ns
;			; 2 = 375ns
;			; 3 = 500ns
;	db  00		;BYTE 9: frei
;
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Aufbau der internen Schnittstelle des FD-Moduls fuer:
;	   ~~~~~~~~	;Lesen / Schreiben			I Formatieren
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;SCHN:	ds	1,0	;  0    :BEFEHL 		(ix)   	I
;LAUFW:	ds	1,0	;  1	:LAUFWERK		(ix+1)	I
;SPUR:	ds	1,0	;  2	:SPUR			(ix+2)	I
;KOPF:	ds	1,0	;  3	:KOPF			(ix+3)	I
;SKT1:	ds	1,0	;  4	:SEKTOR			(ix+4)  I  Sektorinhalt
;DFLDL:	ds	1,0	;  5	:DATENFELDLAENGE      	(ix+5)	I
;GAP:	ds	1,0	;  6	:LUECKE (GAP 3)       	(ix+6)  I  Luecke 3
;SANZ:	ds	1,0	;  7	:SEKTORANZAHL		(ix+7)	I
;VERF:	ds	1,0	;  8	:VERFAHREN		(ix+8)	I
;SPUD:	ds	1,0	;  9	:SCHRITTE/SPUR		(ix+9)	I
;PUFFL:	ds	1,0	; 10	:PUFFERADRESSE (LOW)	(ix+10)	I
;PUFFH:	ds	1,0 	; 11	:PUFFERADRESSE (HIGH)	(ix+11)	I
;
;--------------------------------
;
;DRPB:	ds	1,0	; 12	:LW-Typ MFS 1.6
;	ds	1,0	; 13	:1.Spur m.Praekomp.
;	ds	1,0	; 14	:Schrittzeit SRT/ms (2ms-Schritte)
;	ds	1,0	; 15	:Kopfladezeit HLT/ms (4ms-Schritte)
;	ds	1,0	; 16	:dto.nach Step
;	ds	1,0	; 17	:1.Spur m.Schreibstrombegrenzg.
;	ds	1,0	; 18	:Option f.Kontrollesen
;	ds	1,0	; 19	:Kopfentladezeit HUT in ms(32ms-Schritte)
;	ds	1,0	; 20	:Praekomp.zeit
;	ds	1,0	; 21	:frei
;
;
;Befehlscodierung:
;~~~~~~~~~~~~~~~~~
;	80h  -	Kaltstart (nach POWER ON erf.,sonst u.a. Kopfschleichen!!)
;	70h  -  Lesen gueltiger Sektoren ( Datenmarke FB )
;	50h  -  Schreiben gueltiger Sektoren
;Sonderbefehle:
;~~~~~~~~~~~~~~
;	71h  -  Lesen ID-Feld
;	51h  -  Formatieren einer Spur
;	73h  -  Kontrollesen nach Formatieren (ohne Positionieren)
;	90h  -  LW-Bereittest fuer autom.Formaterkennung
;Moegliche Statusmeldungen:
;--------------------------
;Statusbyte  	Bedeutung
;   00		kein Fehler
;   82		bei aut.Formaterkennung ueber Ruf SELDSK1: ID-Feld nicht lesbar
;   4b		Kontollesefehler nach Schreiben
;   52		LW nicht bereit
;   53		Schreibschutz
;
;   61		allgemeiner Fehler	( FDCM )  | z.B. bei Verklemmung in UP AUSGM
;   62		allgemeiner Fehler	( SPEZ )  | d.h.Bef.-ausgabe an FDC nicht moegl.
;   63		allgemeiner Fehler	( HOME )  | dto bei HOME/SEEK
;   64		allgemeiner Fehler	( ENDEP1) | wenn ein LW dauernd im Suchbetrieb
;
;   40		Meldung entsprechend Fehlerstatus | fehlerhafter Komm.-Abschluss (z.B.CRC-Fehler)
;   80		des Statusreg. ST0 vom FDC	  | neues Komm. vor Abschluss altes befohlen
;   C0		(Bit 6 und 7)			  | RDY-Wechsel eines LW waehrend Komm.-Bearb.
;
;
;Toradressen:
;~~~~~~~~~~~~
FDCSTA	EQU	40H	;Hauptstatusregister FDC
FDCDAT	EQU FDCSTA+1	;Datenregister FDC
ZREG	EQU	48H	;Zusatzregister
 
TCSTOP	EQU	10H	;TC=1: RD/WR-Op. abbrechen (vollst. 4mms-langer H-Imp.erf.!!)
RESFDC	EQU	20H	;FDC-Reset
;
;Ueberwachungszaehler (ACHTUNG: von CPU-Takt abh.;kritisch!!!!)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
UEZEIT	EQU 	0C000H	;Ueberwachgszaehler z.Synch.FDC nach Ausgabe eines Bef.
			;u.Abholen Resultatbytes (z.B.war 6000h b.2,4 MHz in UP idles
			;zw.call ausgm und call eing1 zu kurz. URSACHE: HLT = 0 ent-
			;spricht Max.-Wert = 508 ms(u.wirkt vor jedem Sektor-Kdo.)
POSZA	EQU	1400H	;Abbruchzaehler fuer LW-nicht-bereit vor Positionierung
			;1715W-Wert:= a00h/2,4MHz;1400h auch f.4MHz gueltig !!!
STIME	EQU	174	;Grundwert fuer soft-timer(= 1ms bei 4 MHz !!),z.B.zur
			;Realg. Kopfberuhigungszeit nach Step(Elim.horiz.Schwingens)
KTIME	EQU	3	;Grundwert b.4 MHz-Vers.f.Wartezeit b.Ausgabesynchr.zum FDC
			;z.B.in UP ausgm
;
;------------------------------------------------------------------------------
 
 
BIFM00:
BIFM0:	PUSH IX
	POP HL
	LD (SP00),SP	;Stackpointer retten
	LD (IX00),HL	;Schnittstellenzeiger merken
	LD DE,SCHN
	LD BC,12
	LDIR		;Uebernahme echte Schnittstelle nach schn
			;ACHTUNG: schn hat ab IX+11 neue Belegung !!!!
;
	LD C,(HL)
	INC HL
	LD B,(HL)
	PUSH BC
	POP HL		;HL zeigt auf akt.DRPB!
	LD BC,10
	LDIR		;Uebernahme des DRPB
;
	LD	IX,SCHN ;NEUSETZEN IX auf modulinterne Schnittstelle schn
;
	LD	IY,SPEZT	;FDC-Kommandobytes laden
	LD	(IY+SPEZT-SPEZT),3	;SPEZ (1.Byte jeweils Komm.-laenge)
	LD	(IY+SPEZT+1-SPEZT),3	;Komm.-code
;
;HUT (32ms-Schritte)
	LD A,(IX+19)
	LD B,5
HUT0:	SRL A
	DJNZ HUT0
	LD C,A
;Schrittzeit (2ms-Schritte)
	LD A,(IX+14)
	SRL A
	NEG
	AND 0FH
	LD B,4
SRT0:	SLA A
	DJNZ SRT0
	OR C		;SRT/HUT = 4 ms/32 ms
	LD (IY+SPEZT+2-SPEZT),A
;Kopfladezeit HLT (4ms-Schritte)
	LD A,(IX+15)
	SRL A
	SET 0,A		;ND-Bit hinzu
	LD (IY+SPEZT+3-SPEZT),A ;HLT/ND = 4 ms/ND-Bit ==> 03h
;
	LD	(IY+HOMET-SPEZT),2	;HOME
	LD	(IY+HOMET+1-SPEZT),7	;Komm.-code
	LD	(IY+SEEKT-SPEZT),3	;SEEK
	LD	(IY+SEEKT+1-SPEZT),0FH	;Komm.-code
	LD	(IY+SENSET-SPEZT),1	;SENSE
	LD	(IY+SENSET+1-SPEZT),8	;Komm.-code
	LD	(IY+IDLEST-SPEZT),2	;RD-ID
	LD	(IY+IDLEST+1-SPEZT),4AH	;Komm.-code
	LD	(IY+STATT-SPEZT),2	;LW-Status
	LD	(IY+STATT+1-SPEZT),4	;Komm.-code
	LD	A,9		;Komm.-table/Laenge f.RD/WR-Op.
	LD	(CODET),A
	XOR	A
	LD	(STATB),A	;Status loeschen
;
	LD	A,(IX)
	CP	80H
	JP	Z,KALTS		;Kaltstartkommando
;
;Lese/Schreibwiederhol.zaehler und HOME-Zaehler kommandoabh.laden
;----------------------------------------------------------------
	LD A,(IX)
	CP 90H		;LW-Bereit-Test f.aut.Formaterk.
	JP Z,LWRDY?
;
	CP 51H		;Komm.-code f.Formatieren
	JR Z,M00
	CP 73H		;Komm.-code f.Kontr.-RD nach Formatieren
	JR Z,M00
;
	LD A,5		;Lese/Schreib-Wiederholungszaehler = 05 !! ACHTUNG !!
	LD (LESZ),A	; ==>	bei zu kleinem lesz (z.B.= 2) haeuft sich BAD SECTOR
	LD A,2		;Wenn lesz-mal.Wiederholung der RD/WR-SEC-Op.ohne
	LD (HOMEZ1),A	;Erfolg,dann noch einmal wiederh.mit vorh.HOME.Dad.
			;w.auch solche F.elim.,wie Schlittenpos.ausser-
			;halb Spurber./Disk (z.B.v.Hand verstellt!)
	LD (HOMEZ2),A	;HOME-Zaehler f.Real.HOME b.fehlerh.Kontrolles.nach SEC-WR
	JR SCP2		;          (bei >1 ausserdem zu langsames Format.im F.-Fall)
;
M00:	LD A,4		;Werte f.Rufe 'Form./Kontr.-RD nach Form.' laden
	LD (LESZ),A	;bei lesz=1 laeuft DP FORMAT nicht (b.lesz=6 zu langsam, 
	LD A,2		;wenn fehlerhafter Sec,lesz=2 f.jungfrauel.Disks unguenstig)
	LD (HOMEZ1),A	;homez1=2: Bei fehlerhaft formatiertem Sec einmal.Neupositionieren
;
;
;SEKTORARBEIT mit ggf.Kontroll-RD bei Schreiben (entspr.B3/(ix+18)):
;-------------------------------------------------------------------
;
SCP2:	CALL DISKIO1	;Ausfuehr.der Bef.RD/WR/FORMAT/KLNF/ID-RD,Rueckgabeparam.in A
	LD (STATB),A	;3 Rueckkehrvar.:
			;  1. ohne  Fehler  : zu scp21, A:=0
			;  2. m.F.(ST0 <> 0): zu scp21, A:=<result>:=ST0 (Fehlerklasse 40h,80h,C0h)
			;  3. schwerer F.   : zu fescp,A:=61h,62h,..(direkter Aus-
			;		      sprung z.B.aus UP spez,fdcm,such,pos0
			;		      zu fescp mit Kaltstart)


;Wenn kein Fehler,dann Test,ob WR und wenn ja,ob Kontrollesen 
;------------------------------------------------------------
SCP21:	LD A,(SCHN)
	CP 50H
	JR NZ,ESCP0	;kein Schreiben !
	LD A,(STATB)
	CP 0
	JR NZ,ESCP0	;wenn Fehler b.Schreiben,dann kein CON-RD
			;     ~~~~~~		      ~~~~
	BIT 3,(IX+18)	;B3=0: WR mit CON-RD (u.Beruecksicht.des akt.Wertes/LESZ!)
	JP Z,KL		;Rueckkehr bei keinem F.:  jp escp0
			;       b.fehlerhaft.Sec:  jp scp2 (WR-Wiederholung)
			;	     bei LESZ:=0:  jp escp (Austritt m.F.=4bh)
	JR ESCP0	;B3=1: WR ohne CON-RD
;
;
;Ausgang des physischen Moduls
;-----------------------------
ESCP:	LD (STATB),A	;Absp.A:=01 bei log.F.(log.geloeschter Sec gefunden)
ESCP0:	XOR A		;alle Motoren stop d.SW = 00 (B0/1/2 Motorbits)
			;ACHTUNG: b.Ausg.SW=20h,d.h.SW m.FDC-Reset am Ende jed.RD/WR-Op.
	OUT (ZREG),A	;wuerde PCN (int.Spurzaeh./FDC) auf 0 gesetzt(obwohl FDC n.auf Spur 0 steht!)
			;Dad.wuerde bei naechstem Positionieren im POS0 falsch posit. !!!!!!
;
ESCP1:	LD IX,(IX00)	;IX regener.(auf echte Schnittst.v.Blockungsmod.)
ESCP2:	LD A,(STATB)
	LD (IX+14),A	;<statb> in echter Schnittstelle zurueckgeben
KS3:	LD SP,(SP00)
	RET		;zurueck in aufruf.Modul(BIOS/BDOS)
;
;
;Fehlerhaftes Ende des Moduls, wobei die Fehlerursache nicht weiter verifiziert
;werden kann (Fehlerklasse 60h, 61h, ...).
;------------------------------------------------------------------------------
FESCP:	LD (STATB),A
	CALL KS		;Kaltstart (FDC-Reset + Istspuren ISSPj=FF f.HOME)
	JR ESCP0
;
;------------------------
;
*INCLUDE	7/FDUP1.S	 ;alle UPs
;
;******************************************************************************
