;****************************************************************
;Unterprogramme zu FD-Modul (3,75 MHz-Version)			*
;VERSION: 1. RD-und WR-Op.OHNE vorher.ID-Feld-Lesen beim Posit.	*
;	  2. MIT Zeit-Ueberwachung im Bytehandling der RD/WR-Op.*
;	     durch Soft-Loop					*
;	  3. Implementierung der Befehle 51h/73h/71h/90h --> 	*
;	     51h Formatieren					*
;	     73h Kontrollesen nach Formatieren ohne Positionierg*
;	     71h ID-Feld lesen (Nutzung z.aut.Formatanpassung !)*
;	     90h Abfrage LW-Status				*
;****************************************************************
;file:	FDUP1.S
;date:	03.05.89 / LO
;
;Sektorarbeit:
;Ausfuehrung der Kommandos LESEN/SCHREIBEN/FORMAT/KONTR.-RD nach FORMAT/ID-RD
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
DISKIO1:
DSK0:	LD A,(IX+1)	;Schnittstellencode f.LW0/1/2: 00/01/02 !!
	AND 3
	LD B,A
	LD C,A
	INC B
	LD A,80H	;Motorcode im ZREG f.LW0/1/2 berechnen
DISK0:	RLCA
	DJNZ DISK0
;
	LD HL,ISSP0	;zum akt.LW gehoerige Istsp.-Adr.ber.u.nach
	ADD HL,BC	;aissp abspeichern
	LD (AISSP),HL
;
;Ein/Ausschalten Praecompensation d.B3/ZREG:= 1/0
;------------------------------------------------
;Prae.-Params in DRPBA:  Byte 1/PRA = 1.Spur m.Praecomp.   Byte 8 = Praec.-zeit
;---------------------   Wenn PRA=80 ==> f.keine Spur Praekomp.!!
;
	LD B,A		;Motor-Bits f.zreg retten
	LD A,(IX+13)	;PRA = 1.Spur mit Praecomp.lt.Schnittstelle
	LD C,(IX+2)	;zu bearb.Spur
	INC C
	SUB C		;wenn A < 0,dann akt.Spur ohne Praecomp.
	LD A,B
	JR NC,NOPRAE
	LD C,00001000B	;B3=1: Arbeit mit Praecomp.
	OR C		;spurabhaengig Praecomp.bit zu Motor-Bit dazuodern
			;(z.Z.1.Spur mit Praec.=80,d.h.keine Spur m.Praec.)
;
NOPRAE:	LD (ZREGSP),A	;abspeichern akt.Stand Motorbits(Prae/
			;Res/TC-Bits:=0)
	OUT (ZREG),A	;Motor ein
;
;Einstellung allgemeiner Kommando-
;bytes fuer FDC
;---------------------------------
	LD A,(IX+3)	;aus Kopfbyte Kopfbit HDS ber.
	OR A
	RLCA
	RLCA
	LD B,(IX+1)	;LW-Bits DS0/1 aus LW-Byte hinzuodern
	OR B		;akt.Komm.-byte in A:= 0 0 0 0 0 HDS DS1 DS0 in
	LD (K2CODE),A	;Kommandocode/Byte 2 f. FD-Befehle laden
	LD (STATT+2),A
	LD (SEEKT+2),A
	LD (IDLEST+2),A
;
;FDC programmieren und positionieren entspr.Spur in Schnittstelle (ix+2)
;PRINZIP:  OHNE Kontrolle aktuelle Istspur d.ID-Feldlesen b. RD -u.WR-Op. !!!
;	   Falls ISTsp.in Var.PCN = SOLLsp.in (ix+2),tats.Spur aber anders(z.B.
;	   v.Hand verst.),erfolgen 5 Wiederh.entspr.LESZ u.anschl.1 HOME entspr.
;	   homez1,sodass int.Spurzaehler/FDC=0.Bei nachf.RD/WR-Op.w.dann neuposit.
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;
	CALL SPEZ	;FDC-Reset im Kaltstart,Spezif.FDC b.jedem Posit.,obwohl
			;FDC einmal prog.Werte auch d.Kaltstart/FDC-Reset nicht vergisst.
			;lfd.neue Spez.erf.,weil LW-Param.untersch.sein koennen.	
	CALL POS0	;kein Posit.,wenn (log.)Istspur in PCN = Sollspur in (ix+2);d.h.evtl.falsche
			;Spur/FDC w.im sowieso erfolg.ID-Lesen der nachfolg. RD/WR-Op.erkannt u.ueb.
			;HOME d.anschl.Neuposit.entspr.Stand homez korr.(mittl.Zeitgewinn 100ms/Sec).
;	!!!!------->	;Direkter Aussprung zu escp nach Sonderbef.ID-Lesen
			;(w.f.aut.Formatanpassg in UP seldsk1 benutzt)
 
;Aufbereiten der Sektorinformation
;---------------------------------
	LD HL,SPUR
	LD DE,KSINFO	;Komm.-table f.RD/WR entspr.Sektorinformationen
	LD BC,4		;umladen u.aufbereiten
	LDIR
;
	LD A,(IX)	;Befehl
	CP 51H		;Formatieren (w.beim Formatieren d.DP FORMAT in schn eingetr.)
	JR NZ,FORMV	;nein
	DEC DE		;-----------------------+
	LD A,(SKT1)	;			|
	LD (DE),A	;ksinfo+3 (Datenbyte 0e5h)
	DEC DE		;			|
	LD A,(GAP)	;			|
	LD (DE),A	;ksinfo+2 (Gap3=74h/1024|Ueberladen der 'codet' mit
	DEC DE		;	       =36h/256)|den Informationen, die fuer
	LD A,(SANZL)	;			|das Formatieren erforderlich
	LD (DE),A	;ksinfo+1 (Sekt/Spur)	|sind (siehe Schnittstelle)
	DEC DE		;			|
	LD A,(DFLDL)	;			|
	LD (DE),A	;ksinfo+0 (Bytes/Sekt)	|
			;-----------------------+
;
;formatabh.keot (Nr.letzter Sec/Spur) berechnen
;----------------------------------------------
FORMV:	LD A,(IX+5)	;rel.Datenfeldlnge (1,2,3 ==> 256/512/1024)
	LD HL,KEOT
	LD (HL),5	;Standardwert f.1024-Sec laden
	CP 3
	JR Z,SECK
	LD (HL),9	;keot f.9*512-Format
	CP 2
	JR Z,SECK
	LD (HL),16	;16*256-Format
	CP 1		;26*128-Format
	JR Z,SECK
	LD (HL),26
;
;--------------------------------------
;	ld a,(skt1)	;Berechnung Pseudo-EOT:
;	add a,(ix+7)	;Dad.w.lfd.Aktual.des EOT-Byte keot entspr.
;	dec a		;Disk-Format vermieden.Es w.aus Anfangs-Sec <skt1> u.
;	ld (keot),a	;Anzahl der zu beh.Sec (ix+7) die Nr v.letz.zu beh.Sec
			;ber.u.als scheinbares Spurende eingetrag.Das dann
			;aut.Weiterst.auf naech.Spur/Kopf Sec 1 d.FDC stoert
			;nicht,da diesbez.keine Auswertung erfolgt!!!
;--------------------------------------
;
SECK:	LD A,(IX+6)
	LD (KGPL),A	;Gap3 = Luecke nach Datenfeld: = max.116B b.1024-Sec
	LD A,80H	;Datenfeldlaenge f.80h-sektorierte Disks
	LD (KDTL),A	;(entspr.rel.Laenge n=0)
;
;Berech.Gesamtzahl der zu behand.Bytes aus rel/abs Datenfeldlnge * Anzahl Sec
;----------------------------------------------------------------------------
SECL:	LD B,(IX+5)	;rel. Datenfeldlaenge
	LD HL,40H
	INC B
SECL1:	ADD HL,HL
	DJNZ SECL1
	LD (SKTGR),HL	;abs. Datenfeldlaenge = Anzahl Byte/Sec
	EX DE,HL
;
	LD A,(IX)	;Befehl
	CP 51H		;Formatieren ?
	LD A,9		;Laenge der 'codet' f.RD/WR/SCAN
	JR NZ,VS2
	LD DE,4		;4 Byte pro ID-Feld
	LD A,6		;Laenge der 'codet' f.Formatieren
VS2:	LD (CODET),A
;
	LD HL,0
	LD B,(IX+7)
SECL2:	ADD HL,DE
	DJNZ SECL2
	LD (BLCKL),HL	;Gesamtzahl der zu behand.Bytes
;
;RUF-Verteiler: Komm.-code f.RD/WR/FORMAT/KONTROLL-RD
;----------------------------------------------------
LESEN:	LD A,(IX)
	CP 70H		;Lesen ?
	LD A,46H	;Komm.-code f.RD
	LD (K1CODE),A
	JP Z,REEAD	;ja
;
KONRD:	LD A,(IX)
	CP 73H		;Kontrollesen nach Format.?
	LD A,51H	;Bef.-code f.scan equal
	LD (K1CODE),A
	JP Z,KLNF	;ja
;
;Schreiben einschl.Test WR-protected/Formatieren
SCHREI:	LD A,45H	;Komm.-code f.WR	| Write und Formatieren werden
	LD (K1CODE),A	;			| durch die selbe Routine
	LD A,(IX)	;			| WRRITE ausgefuehrt,da vorher
	CP 50H		;Schreiben ?		| die codet entsprechend
	JR Z,WRPTST	;ja,nun wrpr-Test	| modifiziert wurde
	LD A,4DH	;Komm.-code f.Formatieren
	LD (K1CODE),A
;
WRPTST:	CALL STATLW
	BIT 6,A		;Diskette schreibgeschuetzt ?
	JP Z,WRRITE	;nein
	LD A,53H	;F.-code
	JP ESCP		;Austritt m.F.= 53h
;
;
;-------------------------------------------------------------------------------------
;LESEN EINES/MEHRERER SECTOREN :
;Besonderheit b.dieser Version : Begrenzg.der Wartezeit auf Eintritt Datenbereitschaft
;				 FDC v.ca 0,3s/2,4 MHz,dann raus z.Wiederh.entspr.
;				 lesz/homez1 (b.homez1=0 Austr.m.F.=<ST0>=40,80,c0)
;-------------------------------------------------------------------------------------
;
REEAD:	
	LD HL,CODET
	CALL AUSGM	;FDC f.RD-Op.progr.
	CALL NZ,FDCM
	JR NZ,REEAD
;
	LD BC,(BLCKL)
	LD HL,(PUFFL)
;
;VERSION f.BIC/3,75MHz mit Softloop-Ueberwachung
; (Schleife zum byte-weisen RD in max.0,032 ms) :
;------------------------------------------------
	LD DE,00	;max.Ueberwachgzeit: 65535 * 51T = 0.9s/3,75 MHz
	DI		;DI muesste eig.vor call ausgm,dies hat aber eigene
			;harte F.-Ausgaenge,wo dann ueberall EI stehen muesste
SECRD:	
	DEC DE		;bei BIC(3,75MHz): Schleifenueberwachg.einbinden f.aut.
	LD A,E		;Austritt,wenn B5/7-Hauptstat.reg.staendig 0,d.h.FDC
	OR D		;keine Daten bzw.nicht mehr in Ausfuehrgsphase (z.B.liefert FDC
			;im Hauptstat.-reg. D0h = "Ausf.phase beendet"inf.Desynch.zur.)
	JR Z,RD2	;Austritt z.Ruf-Wiederholung
;
;BYTEHANDLING:
;-------------
SECRD0:	IN A,(FDCSTA)	;Status des FDC holen
	CP 0F0H		;B7B6B5B4 = 1 ==> Ausfuehrungsphase,Daten vorhanden
	JR NZ,SECRD	;bei Desynchr.FDC/CPU meldet FDC z.B. Status = D0h zur.
;
;	DI		;T E S T  24.04.89-->N E G T I V  3.5.89
	IN A,(FDCDAT)
	LD (HL),A
	CPI
	JP PE,SECRD0	;alle abgeholt?
;
	LD A,(ZREGSP)	;letzter akt.Stand zreg (Motorcode)
	OR TCSTOP	;Hinzuodern des TC-Stop (B4-zreg = 1)
	OUT (ZREG),A	;Abbrechen der Uebertragung durch TC-Ausgabe
	RES 4,A		;vollst.4 mms langer H-Impuls
	NOP
	OUT (ZREG),A
;
	IN A,(FDCSTA)	;bedingtes Blindlesen eines ggfs.noch angearb.
	CP 0F0H		;Datenbytes(z.B.wenn kein vollst.Sec gelesen w.)
	JP NZ,RD2	;nein
	IN A,(FDCDAT)	;ja:letztes Datenbyte blindlesen u.verwerfen
;
RD2:	EI
	JP ENDEBH	;d.h.zur f.RD-u.WR-Op.gemeinsamen Endebehandlung,bei
			;F.lesz-fache Wiederholg.,dann Austritt m.F.=<ST0>
;
;
;----------------------------------------------------------
;SCHREIBEN EINES/MEHRERER SECTOREN / FORMATIEREN EINER SPUR
;Ueberwachg Datenbereitabfrage wie b.RD
;----------------------------------------------------------
WRRITE:	LD HL,CODET	;Floppy-Bef.WR/FORM ausloesen
	CALL AUSGM
	CALL NZ,FDCM
	JR NZ,WRRITE
;
	LD HL,(PUFFL)
	LD BC,(BLCKL)
;
;VERSION f.BIC/3,75MHz mit Softloop-Ueberwachung
;------------------------------------------------
	LD DE,00	;max.Ueberwachgzeit: 65535 * 51T = 0.9s/3,75 MHz
	DI		;DI muesste eig.vor call ausgm,dies hat aber eigene
			;harte F.-Ausgaenge,wo dann ueberall EI stehen muesste
SECWR:	
	DEC DE		;bei BIC(3,75MHz): Schleifenueberwachg.einbinden f.aut.
	LD A,E		;Austritt,wenn B5/7-Hauptstat.reg.staendig 0,d.h.FDC
	OR D		;keine Daten/nicht in Ausfuehrgsphase (z.B.FDC-Stat=D0h)
	JR Z,WR2	;Austritt z.Ruf-Wiederholung
;
;BYTEHANDLING:
;Schleife zum byte-weisen WR in max.0,032 ms
;-------------------------------------------
;
SECWR0:	IN A,(FDCSTA)	;Daten bereit u.noch Ausfuehrgsphase(B7B6B5B4:=1011) ?
	CP 0B0H		;B7B6B5B4/Hauptstat.reg. = 1011
			;  ~~==> Richtung CPU/FDC
	JR NZ,SECWR
;
;	DI		;T E S T  24.04.89-->N E G T I V  3.5.89
	LD A,(HL)
	OUT (FDCDAT),A
	CPI		;BC:= 0  ==> P/V-Flag := 1
	JP PE,SECWR0
;
	LD A,(ZREGSP)	;letzter akt. Stand von zreg
	OR TCSTOP	;weitere Uebertrag.d.FDC ueber TC-Bit4/zreg:=1 sperren
	OUT (ZREG),A
	RES 4,A
	NOP
	OUT (ZREG),A
;
WR2:	EI
	JP ENDEBH
;
;------------------------------------------------------------------------
;KONTROLLESEN von 1 kByte nach Formatieren (verschieden zu KON-RD n.WR !)
;Ueberwachg Datenbereitabfrage wie b.RD
;------------------------------------------------------------------------
KLNF	LD A,(IX+2)	;Test Spurnummer
	CP 2
	JR NC,KLNFD	;-->DATENSPUREN
;
KLNFS:	LD HL,CODET	;SYSTEMSPUREN
	CALL AUSGM 	;Floppy-Bef.scan equal ausloesen
	CALL NZ,FDCM
	JR NZ,KLNFS
;
	LD BC,(BLCKL)
;
;VERSION f.BIC/3,75MHz mit Softloop-Ueberwachung
;------------------------------------------------
	LD DE,00	;max.Ueberwachgzeit: 65535 * 51T = 0.9s/3,75 MHz
	DI		;DI muesste eig.vor call ausgm,dies hat aber eigene
			;harte F.-Ausgaenge,wo dann ueberall EI stehen muesste
KLNFS0:	
	DEC DE		;bei BIC(3,75MHz): Schleifenueberwachg.einbinden f.aut.
	LD A,E		;Austritt,wenn B5/7-Hauptstat.reg.staendig 0,d.h.FDC
	OR D		;keine Daten/nicht in Ausfuehrgsphase (z.B.FDC-Stat=D0h)
	JR Z,KLNF2	;Austritt z.Ruf-Wiederholung
;
;BYTEHANDLING:
;Schleife zum byte-weisen CON-RD in max.0,032 ms
;-----------------------------------------------
;
KLNFS1:	IN A,(FDCSTA)	;Daten bereit u.noch Ausfuehrgsphase(B7B6B5B4:=1011) ?
	CP 0B0H		;B7B6B5B4/Hauptstat.reg. = 1011
			;  ~~==> Richtung CPU/FDC
	JR NZ,KLNFS0
;
;	DI		;T E S T  24.04.89-->N E G T I V  3.5.89
	LD A,53H	;Daten fuer Systemspur: 53H
	OUT (FDCDAT),A
	CPI		;BC:= 0  ==> P/V-Flag := 1
	JP PE,KLNFS1
;
	LD A,(ZREGSP)	;letzter akt. Stand von zreg
	OR TCSTOP	;weitere Uebertrag.d.FDC ueber TC-Bit4/zreg:=1 sperren
	OUT (ZREG),A
	RES 4,A
	NOP
	OUT (ZREG),A
	JR KLNF2
;
KLNFD:	LD HL,CODET	;DATENSPUREN
	CALL AUSGM 	;Floppy-Bef.scan equal ausloesen
	CALL NZ,FDCM
	JR NZ,KLNFD
;
	LD BC,(BLCKL)
;
;VERSION f.BIC/3,75MHz mit Softloop-Ueberwachung
;------------------------------------------------
	LD DE,00	;max.Ueberwachgzeit: 65535 * 51T = 0.9s/3,75 MHz
	DI		;DI muesste eig.vor call ausgm,dies hat aber eigene
			;harte F.-Ausgaenge,wo dann ueberall EI stehen muesste
KLNFD0:	
	DEC DE		;bei BIC(3,75MHz): Schleifenueberwachg.einbinden f.aut.
	LD A,E		;Austritt,wenn B5/7-Hauptstat.reg.staendig 0,d.h.FDC
	OR D		;keine Daten/nicht in Ausfuehrgsphase (z.B.FDC-Stat=D0h)
	JR Z,KLNF2	;Austritt z.Ruf-Wiederholung
;
;BYTEHANDLING:
;Schleife zum byte-weisen CON-RD in max.0,032 ms
;-----------------------------------------------
;
KLNFD1:	IN A,(FDCSTA)	;Daten bereit u.noch Ausfuehrgsphase(B7B6B5B4:=1011) ?
	CP 0B0H		;B7B6B5B4/Hauptstat.reg. = 1011
			;  ~~==> Richtung CPU/FDC
	JR NZ,KLNFD0
;
;	DI		;T E S T  24.04.89-->N E G T I V  3.5.89
	LD A,0E5H	;Daten fuer Datenspur: 0E5H
	OUT (FDCDAT),A
	CPI		;BC:= 0  ==> P/V-Flag := 1
	JP PE,KLNFD1
;
	LD A,(ZREGSP)	;letzter akt. Stand von zreg
	OR TCSTOP	;weitere Uebertrag.d.FDC ueber TC-Bit4/zreg:=1 sperren
	OUT (ZREG),A
	RES 4,A
	NOP
	OUT (ZREG),A
;
KLNF2:	EI
	JP ENDEBH
;
;------------------------------------------------------------------------------
;Gemeinsame Behandlung Fehler-Klasse <ST0>:= 40h/80h/C0h bei allen SEC-Operat.
;------------------------------------------------------------------------------
;40h: unnorm.Komm.-abschluss  80h: unvollst.Komm.  C0h: Komm.-Abbruch w.RDY-Wechsel
;
ENDEBH:	CALL EINGM	;Resultatsphase v.RD/WR-Op.abholen (7 Byte)
	LD A,(RESULT)
	AND 0C0H	;B7/6-ST0 = 0: norm.=fehlerfreier Komm.-Abschluss ?
	RET Z		;AUSTRITT 1 ( o.k.-Fall): kein Fehler aufgetreten
			;~~~~~~~~~~~~~~~~~~~~~~~~
;
	LD HL,LESZ	;Fehlerfall:  ==> Ruf lesz-mal (bei falscher Spur -Test result+2-
	DEC (HL)	;~~~~~~~~~~~      innerhalb Spurber.auch m.Positg.) wiederholen
	JR NZ,XX	;		  ~~~~~~~~~ (in dem Fall ID-Lesen d.FDC moegl.)
;
	LD (HL),1	;lesz=1: sonst wegen lesz=0/dec lesz "Quasi-Endlosschleife"!!!
	LD HL,HOMEZ1	;wenn leszmal o.Erfolg wiederholt,dann ist log.ISTsp.in
	DEC (HL)	;Var.PCN zwar = SOLLsp.in (IX+2),Kopf aber ausserh.Spurbereich/Disk.
			;Dann noch homez1-mal wiederh.m.Neupositg.ueber HOME.
	RET Z		;AUSTRITT 2 (irgendein F.): F.-Typ,bei dem lesz/homez1-mal wiederholt
			;~~~~~~~~~~~~~~~~~~~~~~~~~~ wurde.Als F.-Nr w.<result>=ST0 zurueckgegeb.
	JR YY		;Kopf steht ausserhalb Spurbereich/Disk (d.h.FDC kann kein ID-Feld lesen!!)
			;  ===>  Ruf-Wiederholung mit Neupositionieren
;------------------------
XX	LD A,(RESULT+2)	;falsche Spur (B4/ST2 = 1) ?
	BIT 4,A		;Dann Neuposit.ueber HOME (Fall: Kopf falsch,aber innerh.Spurber.)
	JP Z,DSK0	;sonst Ruf-Wiederholung ohne Neupositiong.        ~~~~~~
;
;-----------------------
YY:	LD HL,(AISSP)
	LD (HL),0FFH	;<aissp>:=0ffh ==> HOME in POS0
	JP DSK0		;Ruf-Wiederholung mit Neupositionierung ueber HOME
;
			;AUSTRITT 3 (schwere F.): direkter Aussprung aus den F.-
			;~~~~~~~~~~~~~~~~~~~~~~~~ gener.UPs(z.B.F.=62h in UP spez)
			;			  (==> F.-Klasse OHNE WIEDERHOLUNG !!!)
;
;
;+++++++++++++++++++++++++++++++++++++++++++
;Zeitminimales Lesen einer Nachricht vom FDC
;+++++++++++++++++++++++++++++++++++++++++++
EINGM:	LD HL,RESULT
EING1:	LD A,7		;maximale Anzahl von Resultatsbytes
	LD (ZRES),A
	LD DE,UEZEIT
;
EWAIT:	IN A,(FDCSTA)	;B7=1:	FDC-Datreg.bereit f.RD/WR-Op. ?
	BIT 7,A
	JP Z,FDCNB1
;
	IN A,(FDCSTA)
	BIT 6,A		;B6:=1:  Richtung FDC ==> CPU ?
	JP Z,FDCNB1
;
	IN A,(FDCDAT)
	LD (HL),A		;--------------------,
	INC HL		; Wartezeit          I
	LD A,(ZRES)     ; fuer Reaktion RQM  I
	DEC A           ; des Hauptstatus-   I--- ca.  0,025ms
	LD (ZRES),A     ; registers im FDC   I
	RET Z		;		     I
			;		     I
BSY:	IN A,(FDCSTA)	;solange B4:=1,weit. I
	BIT 4,A		;Result.bytes im FDC I	
	LD A,0		;vorhanden	     I
	RET Z		;kein Resultatsbyte mehr vorhanden
	JP EWAIT	;naechstes Byte abholen
;			;----------------------
FDCNB1:	DEC DE		
	LD A,D		
	OR E
	JP NZ,EWAIT
	OR 2		;A:=02 ==> Fehlerstatus von eingm
	RET 		;Synchronisationsfehler
;
;
;+++++++++++++++++++++++++++++++++++++++++
;Zeitminimale Ausgabe eines Befehls an FDC
;+++++++++++++++++++++++++++++++++++++++++
AUSGM:	NOP
AUSGT1:	LD C,FDCDAT	;Ausgabe des SCAN dauert ca. 0,450 ms
	LD B,(HL)		;bei 2,45 MHz
	INC HL
	LD DE,0
;
RICHT:	IN A,(FDCSTA)	;Richtung: CPU zum FDC ?
	BIT 6,A
	JR NZ,RICHT0	;FDC nicht bereit (falsche Richtung)
;
BEREIT:	IN A,(FDCSTA)	;FDC bereit ?
	BIT 7,A
	JR Z,FDCNB	;FDC nicht bereit
;
FDCOK:	OUTI
	RET Z		;fertig  -----------------------,
FDCNB:	LD A,B		;				I
	LD B,KTIME	; Wartezeit fuer		I
KILLT:	DJNZ KILLT	; Hauptstatusregister		I
	LD B,A		; des FDC			I-- 0,02404ms
	DEC DE		; 				I
	LD A,D		;		  		I
	OR E		; A=Wert des Ueberw.-Zaehlers	I
	NOP		;				I
	JR NZ,BEREIT	;Fehlerstatus fuer ausgm--------,
	NOP
	OR 1		;A:=01 ==> Sychronisationsfehler    	
	RET		
;
RICHT0: CALL FDCM	;Abholen einer unerwarteten Meldung des FDC
	JP RICHT
;
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;U-Programm zum Abholen einer unerwarteten Meldung des FDC
;z.B.in UP ausgm keine LW-Bereitschaft mehr d.DISK-Entnahme
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
FDCM:	IN A,(FDCSTA)
	AND 0C0H	;B7/6-Hauptstatusreg.:= 11 ?
	CP 0C0H		;hat der FDC eine Meldung ???? ( RDY- Wechsel )
	LD A,61H        ;falls nicht, so allgemeinen Fehler ausgeben !!!
	JP NZ,FESCP
;
	CALL EINGM	;FDC-Meldung abholen
	NOP		;eventuell RDY-Wechsel eines
	NOP		;Laufwerkes untersuchen
	NOP
	OR 1		;z-Flag  = 0
	RET
;
;
;+++++++++++++++++++++++++++++++++++++
;Spezifizieren des FDC
;(w.d.FDC-Reset/Kaltstart n.geloescht)
;+++++++++++++++++++++++++++++++++++++
SPEZ:	LD HL,SPEZT	;Adresse des ersten Kommandobytes
	CALL AUSGM	;FDC - Spezifikation
	RET Z
	LD A,62H
	JP FESCP
;
;++++++++++++++++++++++
;Abfrage des  LW-Status
;++++++++++++++++++++++
STATLW:	LD HL,STATT	
	CALL AUSGM
	LD A,0		;verursacht Meldung LWNB in POS0
	RET NZ
	CALL EINGM
	LD A,(RESULT)
	LD (RSTAT),A
	RET
;
;++++++++++++++++++++++++++++++++++++++++++++++
;Spur 0 - Positionierung in 3 Posit.-Schritten:
;		Ist-Spur   ==>  Spur < 16
;		Spur < 16  ==>  Spur 16
;		Spur 16    ==>  Spur 00
;++++++++++++++++++++++++++++++++++++++++++++++
HOOME:	CALL HOME1	;zur 1. Positionierung mit HOME-Komm.
			;(Spur 0 aussen !!!)
	CALL ENDEP	;ev.vorangegang.Pos.-vorgang noch nicht beendet?
;
	LD A,16		;2.Positionierung ab ncn=16,da mit HOME nur ueber
	LD (NCN),A	;max.77 Spuren in einem Schritt pos.w.kann!!
	CALL SUCH	;2.Posit.ausfuehren
;
;------------------------
HOME1:	CALL ENDEP	;Test,ob LW d.ein ev.vorangegang.Suchkom.noch
			;im Suchbetrieb (dann B0..4/Hauptstat.-reg.>< 0 !!)
	LD A,(IX+1)	;LW-Byte aus uebernommener Schnittst.schn
	LD (HOMET+2),A	;nach HOME-Tab.
	LD HL,HOMET	;HOME - Kommando!!
	CALL AUSGM	;Spur 0 anfahren (aber nur max.77 Schritte moegl.)
	JR NZ,SUCH1	;wenn Ausgabe/Ausfuehrung Komm. nicht erfolgreich,
			;dann zu BH "schwerer Fehler"
	LD HL,(AISSP)	;ISSP f.akt.LW := 0
	LD (HL),0	
	RET
;
;+++++++++++++++++++++
;Spur - Positionierung
;+++++++++++++++++++++
SUCH:	LD A,(NCN)
	LD (SEEKT+3),A
	LD HL,SEEKT	;SUCH-Kommando!
	CALL AUSGM
	RET Z		;ausgm kommt b.fehlerfreier Posit.m.Z:=1 zur.
SUCH1:	LD A,63H
	JP FESCP
;
;+++++++++++++++++++++++++++++++++++
;SENSE - Interruptstatus (erf.b.Komm.
;ohne Resultatsphase z.B.RECAL/SEEK)
;+++++++++++++++++++++++++++++++++++
SENSE:	LD HL,SENSET
	CALL AUSGM
	RET NZ
	CALL EINGM	;SENSE-Status abholen (ST0,PCN)
	XOR A
	LD HL,(RESULT)
	LD (SEEKST),HL	;und nach seekst abspeichern
	RET
;
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
;Kopfpositionierung:					+
;       Bei RD-Op. OHNE ID-Feld-Lesen			+
;       Bei WR-Op. OHNE ID-Feld-Lesen			+
;D.h.Spurkontr.nur im ID-Lesen der RD/WR-Op.selbst!!!   +
;Sonderbefehl ID-Feld lesen ->Aussprung zu escp/fescp	+
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++
POS0:	LD HL,POSZA	;Ueberwachungszeit
POSW0:	PUSH HL
	CALL STATLW	;B5/ST3:=1  LW bereit
	POP HL
	BIT 5,A
	JR NZ,POS1	;LW bereit
;
	DEC HL		;LW nicht bereit: Warten entspr.posza
	LD A,H
	OR L
	JR NZ,POSW0
;
	LD A,52H	;LW auch nach Wartezeit nicht bereit
	JP FESCP
;
POS1:	LD A,(IX)	;Befehl
	CP 73H		;Lesen ohne Positionieren
	RET Z
;
	LD HL,HOMEZ	;unwirksam,da bei dieser Version ("RD/WR-Op.OHNE ID-Lesen")
	LD (HL),4	;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	LD HL,(AISSP)	;im POSO vor der RD/WR-Op.kein ID-Feld z.Spurkontr.erfolgt!!!!
	LD A,(HL)		;theor.ISTspur in Var.ISSPj (ggf.nicht ident.m.tats.Kopfpos.)
	CP (IX+2)	;SOLL - Spur
	JR Z,POS3	;Gleichheit
;
POS2:	CP 0FFH		;1.Positionierung nach Kaltstart (als HOME-Posit.)
	CALL Z,HOOME	;oder nach Fehler
;
	LD HL,HOMEZ
	DEC (HL)
	LD A,56H	;Spur nicht gefunden (z.B.Spurnr.>79 = 4fh)
	JP Z,FESCP	;??????????
;
	CALL ENDEP	;Positionierende abwarten
;
	XOR	A	;SEEK
	LD	B,(IX+9)
POS25	ADD	A,(IX+2) ;Schritte=(Spur)*(Schritte pro Spur)
	DJNZ	POS25
	LD	(NCN),A
	CALL	SUCH	;Suchen bis pcn = ncn (momentane = anzufahr.Spur-Nr)
;
	LD A,(IX+16)	;Kopfberuhigungszeit nach Step (10ms) d.softtimer abwarten
	CALL TIME1	;(Eliminierung horizont.Schwingens des Kopfes!)
;
POS3:	CALL ENDEP	;Positionierende abwarten
;
;Code f.Version Sonderbefehl ID-Feldlesen
;----------------------------------------
	LD	HL,(AISSP)	;vermeintlich (d.h.in fehlerlosem Fall tatsaechl.)angefahr.
	LD	A,(IX+2)	;Istspur absp.(im F.-Fall w.lesz-faches Wiederhol.m.HOME
	LD	(HL),A		;in Kauf genommen)  ==>  erhebl.Beschl.der RD-Op.,da mind.
				;40 ms f.RD eines ID-Feldes der angefahr.Spur entfallen !!!!
;
	LD A,(SCHN)	;Befehlscode
	CP 71H
	JR Z,IDRD
;
	RET		;Abschluss von POS0 f. RD/WR-Op.
;ID-Feld der aktuellen Spur lesen
;ID:	ST0 ST1 ST2 Cyl Hd R(Sec) N(Byt/Sec)
;-------------------------------------------
IDRD:	CALL IDLES	;ACHTUNG: im UP idles Austritt m.F.=61h,wenn UEZEIT zu
			;	  kurz (z.B.= 6000h/6800h ==> F./kein F.b.2,4MHz !!)
	JR Z,IDRD0	;gesetztes Z-Flag = erfolgreiches Lesen
	LD A,82H	;eigentlich:falscher Kopf/hier:ID-Feld nicht lesbar
	JP ESCP		;bzw.nicht vorhanden (unformatierte Disk)
;
IDRD0:	XOR A		;Status = 0 setzen
	JP ESCP0	;zum Ende von bifm springen (ID-Feld wird im modifi-
			;zierten seldsk ausgewertet)
;
;++++++++++++++++++++++++++++++++
;Ende der Positionierung abwarten
;++++++++++++++++++++++++++++++++
ENDEP:	PUSH AF
	PUSH HL		
	LD HL,UEZEIT
ENDEP1:	DEC HL
	LD A,L
	OR H
	LD A,64H
 	JP Z,FESCP	;undefinierter Fehler
	IN A,(FDCSTA)	;ist irgendein LW noch im Suchbetrieb,
	AND 01FH	;d.h.B0..4/Hauptstatreg. >< 0  ?
	JR Z,POPR	;nein
;	
	PUSH HL
	CALL SENSE	;Abschluss von SEEK oder HOME; SENSE liefert
			;erst n.erfolg.Kom.-Ende guelt.ST0 u.PCN (vorher
	POP HL		;hat ST0 den Wert 80h!!)
	JR ENDEP1
POPR:	POP HL
	POP AF
	RET
;
;+++++++++++++
;ID-Feld-Lesen
;+++++++++++++
IDLES:	LD HL,IDF
	LD B,7		;7 Bytes: ST0 ST1 ST2 Cyl Head Rec N (rel.Datfeldlng)
IDLES0:	LD (HL),0EEH	;Statusfeld loeschen mit EEH
	INC HL
	DJNZ IDLES0
IDLES1:	LD HL,IDLEST
	CALL AUSGM	;ACHTUNG: UEZEIT=6000h zw.ausgm/eing1 b.2,4MHz zu
	LD HL,IDF	;	  kurz,schon 6800h reicht,gewaehlt aber
	CALL EING1	;	  FFFFh (ausreichend auch b.3,75 MHz)
;
	LD BC,4		;ID-Feld-Werte zurueckladen auf uebergeb.PUFF
	LD HL,IDF+3	;f.Auswertung in aut.Formaterkennung
	LD E,(IX+10)
	LD D,(IX+11)
	LDIR
;
	LD B,A
	LD A,(IDF)
	AND 0C0H
	OR B
	RET		;Z :wenn i.O.
;
;++++++++++++++
;Zeit-Programmm
;++++++++++++++
			;Anwendg z.B.f.Real.Kopfberuhigungszeit nach Step
TIME0:	LD A,1		;Einstellung in ms bei 2,4 MHz
TIME1:	LD B,STIME	;Soft-Timer: 1 ms
TIME2:	OR A
	DEC B
	JR NZ,TIME2
	DEC A
	JR NZ,TIME1
	RET
;
;
;+++++++++++++++++
;Kaltstartfunktion
;+++++++++++++++++
KALTS:	XOR A
	LD (ZREGSP),A	;Zw.-Sp.f.zreg: alle Motoren aus
	LD HL,ISSP0
	LD (AISSP),HL
;
	CALL KS
	JP ESCP0
;
KS:	LD B,3
	LD HL,ISSP0
KS0:	LD (HL),0FFH	;issp0/1/2 := 0ffh f.Real.HOME in POS0
	INC HL		;		   bei Kaltstart/Fehler
	DJNZ KS0
;
	LD A,(ZREGSP)	;zreg m.akt.Stand PRAE/MOTOR-Bits (s.S1-4)
	SET 5,A		;vollst.H-Impuls F.FDC-Reset Progr. (> 3,5mms)
	OUT (ZREG),A	;PRAE/MOT-Bits unbeinfl.
	NOP
	NOP
	RES 5,A
	OUT (ZREG),A	;FDC-Reset (FDC-Programmg w.dad.nicht geloescht)
	RET		
;
;
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;Kontrollesen: Wenn beim Sec-WR kein Fehler aufgetreten,wird
;	       bei B3/(ix+18)=0 in UP DISKIO UP kl aufgerufen.
;	       Dabei w.Sec f.Sec der Pufferinhalt m.den Disk-
;	       daten verglichen.Bei F.w.ab def.Sec nochm.geschr.
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
KL:	LD A,1		;STP-Byte in SCAN-Komm.auf 1: Sec in
	LD (KDTL),A	;ununterbrochener Reihe vergleichen
	LD A,51H	;SCAN-Kommandocode(Sec-Vergleich)
	LD (K1CODE),A
	LD HL,(SKTGR)	;Sec-laenge
	LD (BLCKL),HL	;Blocklaenge enthaelt nun Laenge eines Sektors
;
K1:	LD A,(SKT1)	;akt.Sec-Nr
	LD (KEOT),A	;als Pseudo-EOT eintr.
	LD (KSINFO+2),A	;akt.Sektor-Nr in Komm.-table eintragen
;
SCAN:	LD HL,CODET	;Floppy-Bef.SCAN ausloesen
	CALL AUSGM
	CALL NZ,FDCM
	JR NZ,SCAN
;
	LD HL,(PUFFL)
	LD BC,(BLCKL)
;
;Ueberwachung bei BIC (3.75 MHz!) d.Softschleife (im BC 5120 mit K2/3 ZRE-CTC)
;-----------------------------------------------------------------------------
	LD DE,00	;max.Ueberwachgzeit: 65535 * 51T = 0,9 s/3,75MHz)
	DI
SECSC:
	DEC DE		;Schleifenueberwachg.f.aut.Austritt nach 0,9 s/3,75 MHz
	LD A,D		;wenn B5/7-Hauptstat.reg.staendig 0,d.h.FDC
	OR E		;keine Daten bezw.nicht in Ausfuehrungsphase
	JR Z,SC2	;Austritt z.Wiederholung
;
;Schleife zum byte-weisen SCAN = Puffer-Ausgabe an FDC in max. 32 mms
;--------------------------------------------------------------------
SECSC0:	IN A,(FDCSTA)	;Daten bereit u.noch Ausfuehrgsphase(B7B6B5B4:=1011) ?
	CP 0B0H		;B7B6B5B4/Hauptstat.reg. = 1011
			;  ~~==> Richtung CPU/FDC
	JR NZ,SECSC
;
;	DI		;T E S T  24.04.89-->N E G T I V  3.5.89
	LD A,(HL)
	OUT (FDCDAT),A	;Byte kontrollesen
	CPI
	JP PE,SECSC0
;
	LD A,(ZREGSP)	;letzter akt.Stand von zreg
	OR TCSTOP	;weitere Uebertragung d.FDC ueber TC:=1 sperren
	OUT (ZREG),A
	RES 4,A
	NOP
	OUT (ZREG),A
;
SC2:	EI
;
	CALL EINGM	;Resultat vom FDC abholen
	LD A,(RESULT)	;und auf Fehler untersuchen
	AND 0C0H	;Normaler = fehlerfreier Komm.-Abschluss?
	JR NZ,KF	;FDC-Fehler aufgetreten ==> Wdh.ab fehlerh.Sec.
;
	LD A,(RESULT+2)	;Sec-Vergleich o.k.(B3/ST2:=1) ?
	BIT 3,A
	JR Z,KF		;Schreibwiederholung ab fehlerhaftem Sektor!
;	
	INC (IX+4)	;akt. Sec-Nr. inkrementieren
	LD HL,(PUFFL)	;akt. Pufferadresse
	LD DE,(SKTGR)
	ADD HL,DE
	LD (PUFFL),HL	;Anfangsadresse fuer naechstes Schreiben
	DEC (IX+7)	;sanz-1
	XOR A
	JP Z,ESCP0	;Austritt: Kontrollesen fehlerfrei beendet
			;~~~~~~~~~
	JR K1		;naechsten Sektor vergleichen
;
KF:	LD HL,LESZ
	DEC (HL)
	JP NZ,SCP2	;Schreibwiederholung ab
			;fehlerhaftem Sektor!
	LD (HL),1	;lesz=1 z.Verhinderg Endlosloop im Fall lesz=0/dec lesz
	LD HL,HOMEZ2	;home-Zaehler nur f.Schreibwiederhlg.nach fehlerh.Kon.-
	DEC (HL)	;lesen m.Spur0-Anfahren b.Vers.:'SEC-RD/WR-Arbeit
	JP NZ,SCP2	;OHNE vorher.ID-Feldlesen im POSO'
;
	LD A,4BH
	JP ESCP		;Austritt mit Fehler 4bh
;
LWRDY?:	LD	A,(IX+3)	;KOPFBIT B2 SETZEN
	OR	A
	RLCA
	RLCA
	LD	B,(IX+1)	;LW-Bits B0/1 setzen
	OR	B
	LD	(STATT+2),A
	AND	3
	INC	A
	LD	B,A
	LD	A,80H
LWRD0	RLCA
	DJNZ	LWRD0
	LD	(ZREGSP),A
	OUT	(ZREG),A	;Motor ein
	LD	HL,POSZA	;Ueberwachung
LWRD1	PUSH	HL
	CALL	STATLW
	POP	HL
	AND	30H		;Bit5/ST3=1: LW bereit	     )
	JP	NZ,ESCP		;Bit4/ST3=1: Spur 0 erreicht )LW vorhanden
;
	DEC	HL
	LD	A,H
	OR	L		;Zeit vorbei ?
	JR	NZ,LWRD1	;Nein, weiter warten
	JP	FESCP
;
;******************************************************************************
