#/usr/bin/perl
# 26.03.2018 vpohlers
# UDOS-Disketten extrahieren (speziell f. BIC-Quellen)
#
# Disks wurden von Rdiger mit catweasel ausgelesen (DMK-Dateien)
# 1. Schritt: disk.dmk mit dmk2jv3.exe (udos) konvertieren 
# 	das ist meine angepasste Version aus cw2dmk-4.4.zip
# 	die die zustzlichen Verlinkungsbytes mit auslagert
# 	(Sektorlnge 128 Byte + prev Adress + next Adress = 132 Byte)
# 2. Schritt: mit diesem Skript die Daten extrahieren
# 	es wird vorr., dass das DIRECTORY auf 0x16,5 liegt und 
# 	aktuell nur 1 Record gro ist.
#

# disk.dmk mit dmk2jv3.exe (udos) konvertiert
# konvertiertes Image einlesen
open IN, 'disk.dsk';
binmode IN;
do {
	$size = sysread IN, $buffer, 8192;
	$disk .= $buffer;
} until ($size==0);
close IN;

#DISK006 beginnt mit track Nr. 1
$trackoffset = unpack "C",substr($disk, 0, 1);

#image length
print length($disk), "\n";

#directory 
my ($track, $sec) = (0x16, 0x05); # Startrecord directory ?
$pos = getaddr($track, $sec);
printf "DI %6X\n", $pos; # addr. anzeigen
$pos = index($disk, 'DIRECTORY')-1;
printf "DI %6X\n", $pos; # addr. anzeigen

# Schleife durchs directory; erstes File ist dabei das Directory selbst
$pos0 = $pos;
while (1) {
	$laenge = unpack "C",substr($disk, $pos+0, 1);
	#print "laenge $laenge\n";
	if ($laenge == 255) {
		# nchster block
		($sec, $track) = unpack "CC", substr($disk, $pos0+130, 2);
		last if $track == 255;
		$pos = getaddr($track, $sec);
		$pos0 = $pos;
		# print "-> $track, $sec\n";
		next;
	}
	$pos += 1;
	$laenge = $laenge & 31;
	$name = substr($disk, $pos, $laenge);
	$pos += $laenge;
	# printf "%6X\n", $pos;
	($sec, $track) = unpack "CC", substr($disk, $pos, 2);
	$pos += 2;
	print "$laenge $name $track, $sec\n";
	writefile ($name, $track, $sec);
}


# Adresse im image ermitteln aus track und sector
sub getaddr {
	my ($track, $sec) = @_;
	my $pos =  (($track-$trackoffset) * 26 + ($sec) ) * 132 + 0x2200;
	return $pos;
}

# verkettung verfolgen; Datei ausgeben
sub writefile {
	my ($name, $track, $sec) = @_;
	open OUT,">$name" or die;
	binmode OUT;
	# ersten Record bergehen
	my $pos = getaddr($track, $sec);
	($sec, $track) = unpack "CC", substr($disk, $pos+130, 2);
	
	while ($track != 255) {
		# print "$track, $sec\n";
		
		$pos = getaddr($track, $sec);
		syswrite OUT, substr($disk, $pos, 128);
		
		($sec, $track) = unpack "CC", substr($disk, $pos+130, 2);
	}
	close OUT;
}

__END__

1. Record:

00 00 00 00 00 00
DSA 05 16	directory addr
FRA 09 15	first record address
LRA 18 43	last record address (dez 67 24)
